       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRDATCLF.
      *
      * Routine di ricalcolo dati contabili (esclusi saldi) clienti/fornitori
      *
      * In Input : AZI  = azienda  (0 = tutte)
      *            FL   = 0 - esercizio corrente 
      *                   1 - vecchio esercizio
      *
      **** rel 4.0
      * Nuovo
      ************
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'grimovsl'.
           COPY 'griclfsl'.
      **** rel 5.1
           COPY 'grifcdsl'.
      ************
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grimov'.
           COPY 'griclf'.
      **** rel 5.1
           COPY 'grifcd'.
      ************
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parlk'.
           COPY 'griazirk'.
           COPY 'grimovrk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit14g'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
      **** rel 5.1
       01  ID-FCD PIC X(15) VALUE 'forncd'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-CLF   PIC XX.
      **** rel 5.1
           05 SF-FCD  PIC XX.
      ************
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 CIVAV   PIC 9(7).
           05 CIVAQ   PIC 9(7).
           05 CIVA    PIC 9(7) COMP-3.
           05 NREG    PIC 9(5).
           05 TREG    PIC 9.
           05 PART    PIC 9(7).
           05 IMPON   PIC S9(11)V99.
           05 NIMPO   PIC S9(11)V99.
           05 ESENT   PIC S9(11)V99.
           05 IMIVA   PIC S9(11)V99.
           05 TACCR   PIC S9(11)V99.
           05 NFATT   PIC S9(5).
           05 NOPNI   PIC S9(5).
           05 NACCR   PIC S9(5).
           05 IMP     PIC S9(11)V99.
           05 IVN     PIC S9(11)V99.
           05 IVA     PIC S9(11)V99.
           05 SEGNO   PIC 9.
           05 TIPOP   PIC 99.
           05 CDCORR     PIC 9(7) VALUE ZERO.
      **** rel 5.1
           05 DTDOC   PIC 9(5) VALUE ZERO.
           05 DTAPE   PIC 9(5) VALUE ZERO.
      ************
      **** rel 7.2
           05 FLGIS   PIC 9.
           05 CIVSO   PIC 9(7).
      ************
       LINKAGE SECTION.
       01 RS-AZI PIC 9(3).
       01 RS-FL  PIC 9.
       PROCEDURE DIVISION USING RS-AZI RS-FL.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclmov'.
           COPY 'dclclf'.
      **** rel 5.1
           COPY 'dclfcd'.
      ************
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      *
           MOVE 'anaazi' TO ID-AZI.
           MOVE 'anaclf' TO ID-CLF.
      **** rel 5.1
           MOVE 'forncd' TO ID-FCD.
      ************
           MOVE 'tabell' TO ID-TAB.
           IF RS-FL = 1
              MOVE 'anazol' TO ID-AZI
              MOVE 'anacfx' TO ID-CLF
      **** rel 5.1
              MOVE 'forncx' TO ID-FCD
      ************
              MOVE 'tabold' TO ID-TAB.
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN I-O ANACLF.
      **** rel 5.1
           OPEN I-O FORNCD.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB 
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
      **** rel 7.2
           MOVE T01-CIVSO TO CIVSO.
      ************
      *
           MOVE 14 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB 
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-CDCOR TO CDCORR.
      *
           MOVE LOW-VALUE TO KEYAZ.
           IF RS-AZI NOT = ZERO MOVE RS-AZI TO KAZ-COD.
           START ANAAZI KEY NOT < KEYAZ INVALID GO TO END-AZI.
       RD-AZI.
      **** rel 5.1
      *    READ ANAAZI NEXT AT END GO TO END-AZI.
           READ ANAAZI NEXT INTO REKAZI AT END GO TO END-AZI.
      ************
           IF SF-AZI = '9D' OR '9A' OR '35' GO TO RD-AZI.
           IF RS-AZI NOT = ZERO 
              IF KAZ-COD NOT = RS-AZI GO TO END-AZI.
      *
           PERFORM AZZ-CLF THRU EX-AZZ-CLF.
      *
      **** rel 5.1
           PERFORM AZZ-FCD THRU EX-AZZ-FCD.
           MOVE AZI-DTAPE TO DTAPE.
      ************

           IF RS-FL = ZERO
              MOVE 'movmxx' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99
              MOVE 'movime' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99
           ELSE
              MOVE 'movoxx' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99
              MOVE 'movmol' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99.
      *
           GO TO RD-AZI.
       END-AZI.
      *
           GO TO FINE.
      * -------------- *
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACLF.
      **** rel 5.1
           CLOSE FORNCD.
      ************
           EXIT PROGRAM.
           STOP RUN.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grimover'.
           COPY 'griclfer'.
      **** rel 5.1
           COPY 'grifcder'.
      ************
           COPY 'gritaber'.
           COPY 'grixxxer'.
      * --------------- *
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      * --------------- *
       A00-TRATTA-FILE.
           OPEN INPUT MOVIME.
           IF SF-MOV > ZERO GO TO A99.
      
      *** Vendite
           MOVE CIVAV TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      
      *** Corrispettivi
           MOVE CDCORR TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      
      *** Acquisti
           MOVE CIVAQ TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      
      **** rel 7.2
      *** IVA Sospesa/Scissione pagamenti
           MOVE CIVSO TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      
      ************
           CLOSE MOVIME.
       A99. EXIT.
      *-----------------------------------
       B00-CONTO-IVA.
           MOVE ZERO TO MOV-NPRGI.
      
           MOVE 99999   TO NREG.

           MOVE LOW-VALUE TO KEYMV.
           MOVE KAZ-COD   TO KMV-AZI.
           MOVE CIVA      TO KMV-CON.
           START MOVIME KEY > KEYMV INVALID GO TO B90.
       B10.
           READ MOVIME NEXT INTO REKMOV AT END GO TO B90.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO B10.
           IF KMV-AZI > KAZ-COD GO TO B90.
           IF KMV-CON > CIVA    GO TO B90.

           IF MOV-FLAG = 1 GO TO B10.

           IF CIVA = CIVAV
              IF MOV-TIP = 4 GO TO B10.

           IF KMV-CON = CDCORR AND MOV-TREG NOT = 2
              GO TO B10.

      **** rel 7.2
           MOVE ZERO TO FLGIS.
      ************
           IF MOV-NREG NOT = NREG 
              PERFORM C00-CAMBIO-DOC THRU C99.
      **** rel 7.2
           IF FLGIS = 2
              GO TO B10.
      ************

           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-MOV
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      

           IF MOV-TIP = 4 MOVE MOV-IML TO IMP
           ELSE           MOVE MOV-IMP TO IMP.

           IF TIPOP = 8 ADD IMP TO TACCR 
                        COMPUTE IMP = - IMP.

           IF T03-TPIVA < 2 OR T03-TPIVA = 7
              ADD IMP TO IMPON.

      **** rel 5.0
      *    iF T03-TPIVA > 1 AND T03-TPIVA < 6
           IF T03-TPIVA > 1 AND T03-TPIVA < 6
              ADD IMP TO ESENT.
      ************

           IF T03-TPIVA = 6 
              ADD IMP TO NIMPO
              IF SEGNO = ZERO ADD 1 TO NOPNI
              ELSE            SUBTRACT 1 FROM NOPNI.

           IF MOV-TIP = 4 MOVE MOV-INL TO IVN
           ELSE           MOVE MOV-IVN TO IVN.

           IF KMV-CON = CDCORR AND MOV-TREG = 2
                MOVE IVN TO IVA
           ELSE COMPUTE IVA = MOV-IMPO + IVN.

           IF TIPOP = 8 SUBTRACT IVA FROM IMIVA
           ELSE         ADD IVA TO IMIVA.

      **** rel 5.1
           MOVE MOV-DTDOC TO DTDOC.
      ************

           GO TO B10.
       B90.
           PERFORM C00-CAMBIO-DOC THRU C50.
       B99. EXIT.
      *-----------------------------------
       C00-CAMBIO-DOC.
           IF NREG = 99999 GO TO C50.

       RD-CLF.
           MOVE KAZ-COD  TO KCF-AZI.
           MOVE PART     TO KCF-COD.
           READ ANACLF INTO REKCLF KEPT LOCK INVALID PERFORM INVK-CLF
                                                     PERFORM VISK-MOV
                                                     GO TO ERRIO.
           IF SF-CLF NOT = ZERO PERFORM REC-LOCK
                                GO TO RD-CLF.
      **** rel 5.1
           IF CIVA NOT = CIVAQ GO TO OK-CLF.
           IF DTDOC >= DTAPE   GO TO OK-CLF.
       RD-FCD.
           MOVE KEYCF TO KEYFD.
           READ FORNCD KEPT LOCK INVALID
                                 MOVE ZERO  TO RF-FCD
                                 MOVE KEYCF TO KEYFD
                                 WRITE RF-FCD INVALID PERFORM INVK-FCD
                                                      GO TO ERRIO.
           IF SF-FCD NOT = ZERO PERFORM REC-LOCK
                                GO TO RD-FCD.
           ADD  IMPON    TO FCD-IMPON.
           ADD  NIMPO    TO FCD-NIMPO.
           ADD  ESENT    TO FCD-ESENT.
           ADD  IMIVA    TO FCD-IMIVA.
           ADD  TACCR    TO FCD-TACCR.
           ADD  NFATT    TO FCD-NFATT.
           ADD  NOPNI    TO FCD-NOPNI.
           ADD  NACCR    TO FCD-NACCR.
           REWRITE RF-FCD INVALID
                   PERFORM INVK-FCD
                   PERFORM VISK-MOV 
                   GO TO ERRIO.

            UNLOCK FORNCD.
            GO TO NO-CLF.
       OK-CLF.
      ************

           ADD  IMPON    TO CLF-IMPON.
           ADD  NIMPO    TO CLF-NIMPO.
           ADD  ESENT    TO CLF-ESENT.
           ADD  IMIVA    TO CLF-IMIVA.
           ADD  TACCR    TO CLF-TACCR.
           ADD  NFATT    TO CLF-NFATT.
           ADD  NOPNI    TO CLF-NOPNI.
           ADD  NACCR    TO CLF-NACCR.
           REWRITE RF-CLF FROM REKCLF INVALID
                   PERFORM INVK-CLF
                   PERFORM VISK-MOV 
                   GO TO ERRIO.
      **** rel 5.1
       NO-CLF.
      ************
            UNLOCK ANACLF.
       C50. EXIT.
       C60.
           MOVE MOV-NREG  TO NREG.
           MOVE MOV-TREG  TO TREG.
           MOVE MOV-PART  TO PART.

           MOVE ZERO TO IMPON NIMPO ESENT IMIVA TACCR.
           MOVE ZERO TO NFATT NOPNI NACCR.

           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-MOV
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-SEGNO TO SEGNO.
           MOVE T02-TIPOP TO TIPOP.
      **** rel 7.2
           MOVE T02-FLGIS TO FLGIS.
      ************

           IF T02-CTRFT > ZERO
              IF SEGNO = ZERO ADD 1 TO NFATT
              ELSE SUBTRACT 1 FROM NFATT.

           IF T02-CTRAC > ZERO
              IF SEGNO = ZERO ADD 1 TO NACCR
              ELSE SUBTRACT 1 FROM NACCR.
       C99. EXIT.
      *-----------------*
       AZZ-CLF.
           MOVE LOW-VALUE TO KEYCF.
           MOVE KAZ-COD   TO KCF-AZI.
           START ANACLF KEY NOT < KEYCF INVALID GO TO EX-AZZ-CLF.
       AZZ-CLF-10.
           READ ANACLF NEXT INTO REKCLF KEPT LOCK AT END 
                                                GO TO EX-AZZ-CLF.
           IF SF-CLF NOT = ZERO PERFORM REC-LOCK
                                GO TO AZZ-CLF-10.
           IF KCF-AZI > KAZ-COD UNLOCK ANACLF
                                GO TO EX-AZZ-CLF.

           MOVE ZERO TO CLF-IMPON
                        CLF-NIMPO
                        CLF-ESENT
                        CLF-IMIVA
                        CLF-TACCR
                        CLF-NFATT
                        CLF-NOPNI
                        CLF-NACCR.

           REWRITE RF-CLF FROM REKCLF INVALID
                   PERFORM INVK-CLF
                   PERFORM VISK-MOV 
                   GO TO ERRIO.

           UNLOCK ANACLF.
           GO TO AZZ-CLF-10.
       EX-AZZ-CLF.
           EXIT.
      *-----------------*
      **** rel 5.1
       AZZ-FCD.
      **** rel 5.2
           MOVE LOW-VALUE TO KEYFD.
      ************
           MOVE KAZ-COD   TO KFD-AZI.
           START FORNCD KEY NOT < KEYFD INVALID KEY GO TO EX-AZZ-FCD.
       AZZ-FCD-10.
           READ FORNCD NEXT KEPT LOCK AT END GO TO EX-AZZ-FCD.
           IF SF-FCD NOT = ZERO PERFORM REC-LOCK
                                GO TO AZZ-FCD-10.
           IF KFD-AZI > KAZ-COD UNLOCK FORNCD
                                GO TO EX-AZZ-FCD.
           MOVE ZERO TO FCD-IMPON
                        FCD-NIMPO
                        FCD-ESENT
                        FCD-IMIVA
                        FCD-TACCR
                        FCD-NFATT
                        FCD-NOPNI
                        FCD-NACCR.

           REWRITE RF-FCD INVALID
                   PERFORM INVK-FCD
                   PERFORM VISK-MOV 
                   GO TO ERRIO.

           UNLOCK FORNCD.

           GO TO AZZ-FCD-10.
       EX-AZZ-FCD.
           EXIT.
      *-----------------*
      ************
