       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT110.
      *
      * OGGETTO: Calcolo fattura ed effetti
      *
      *--------------------------------------------------------------
      * Note:
      * - IF-ST : oltre ai valori soliti, puo' essere restituito:
      *           ST = 2 per richiedere all'interfaccia l'input
      *           della data 1a scadenza
      *           o data 1a scad. errata (errore validazione)
      *--------------------------------------------------------------
      *
      **** rel 4.0
      * ricompilato
      ************
      **** rel 1.2
      * ricompilato per variazione tracciato FATTUR
      ************
      **** rel 6.0
      * Ricompilato per variazione tracciato tabella pagamenti
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'gricggsl'.
           COPY 'griclfsl'.
           COPY 'grifatsl'.
           SELECT RAGBOL ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC  RECORD KEY KEYRB STATUS SF-RGB.
           SELECT WDSCLI ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC  RECORD KEY KEYCL STATUS SF-CLI.
           COPY 'gritabsl'.
      **** rel 7.1
           COPY 'griactsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'griclf'.
           COPY 'gritab'.
           COPY 'grirbl'.
           COPY 'gricgg'.
           COPY 'grifat'.
      **** rel 7.1
           COPY 'griact'.
      ************
       FD  WDSCLI LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-CLI
           RECORD  14 DATA RECORD RF-CLI.
       01  RF-CLI.
           02 KEYCL.
              05 KCL-AZI PIC 999.
              05 KCL-CLI PIC 9(5).
           02 CLI-TNUM   PIC 9.
           02 CLI-NBOL   PIC 9(5).
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'griazirk'.
           COPY 'grit25rk'.
           COPY 'rekt23'.
           COPY 'parcf'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 1.2
           COPY 'parrb'.
           COPY 'parlk'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-RGB PIC X(15) VALUE 'ragbol'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-CLI PIC X(15) VALUE 'wdscli'.
       01  ID-CGG PIC X(15) VALUE 'camgio'.
       01  ID-FAT PIC X(15) VALUE 'fattur'.
      **** rel 7.1
       01  ID-ACT PIC X(15) VALUE 'appbct'.
      ************
       01  COMODI.
           05 SF-TAB     PIC XX.
           05 SF-AZI     PIC XX.
           05 SF-BCT     PIC XX.
           05 SF-BCR     PIC XX.
           05 SF-RGB     PIC XX.
           05 SF-CLI     PIC XX.
           05 SF-CLF     PIC XX.
           05 SF-CGG     PIC XX.
           05 SF-FAT     PIC XX.
      **** rel 7.1
           05 SF-ACT     PIC XX.
      ************
           05 MESS       PIC X(40) VALUE SPACE.
           05 SWINI      PIC 9     VALUE ZERO.
           05 FUN-PREC   PIC X     VALUE ZERO.
           05 VFLD       PIC 9.
           05 FUN        PIC X.
           05 CAMPO      PIC X(20).
           05 VCAMPO     PIC X(20).
           05 FLGIS      PIC 9.
      **** rel 6.1
      *    05 COMROT     PIC X(27).
      **** rel 6.3
      *    05 COMROT     PIC X(33).
      **** rel 7.1
      *    05 COMROT     PIC X(35).
           05 COMROT     PIC X(67).
      ************
      ************
      ************
      **** rel 1.2
      *    05 K          PIC 99.
           05 K          PIC 9(4).
      ************
           05 DTFATPK    PIC 9(5) COMP-3.
           05 DATIVB     PIC X(8).
           05 DTAIVA     PIC 9(5) COMP-3.
           05 OLD-ULTFAT PIC 9(5).
           05 OLD-ULTEF  PIC 9(5).
           05 OLD-FTSOS  PIC 9(5).
           05 CODCLI.
              10 MAS     PIC 99.
              10 COD     PIC 9(5).
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-CATT      PIC X.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CLI-1     PIC 9(5).
           05 IF-CLI-1-D   PIC X(36).
           05 IF-CLI-2     PIC 9(5).
           05 IF-CLI-2-D   PIC X(36).
           05 IF-BOL-1     PIC 9(5).
           05 IF-BOL-2     PIC 9(5).
           05 IF-TNU-1     PIC 9.
           05 IF-TNU-2     PIC 9.
           05 IF-DTFAT     PIC 9(6).
           05 IF-TPFT      PIC 9.
           05 IF-GGESC     PIC 99.
           05 IF-ULTFAT    PIC 9(5).
           05 IF-ULTEF     PIC 9(5).
           05 IF-FTSOS     PIC 9(5).
           05 IF-FLGIS     PIC 9.
      * data 1a scadenza da input
           05 IF-DATA      PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclclf'.
           COPY 'dclfat'.
           COPY 'dcltab'.
           COPY 'dclcgg'.
      **** rel 7.1
           COPY 'dclact'.
      ************
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==RGB==
                                   ==NFILE== BY ==RAGBOL==
                                   =='nfile'== BY =='ragbol'==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==CLI==
                                   ==NFILE== BY ==WDSCLI==
                                   =='nfile'== BY =='wdscli'==.
      *
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' OR
                    'B' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF K = ZERO
                           GO TO CHIUDI
                        ELSE
                           GO TO FINE.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vfat110: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE WDSCLI ANAAZI BOLCTE BOLCRI
                 ANACLF TABELL CAMGIO RAGBOL.
           OPEN OUTPUT WDSCLI RAGBOL.
           CLOSE WDSCLI RAGBOL.
      **** rel 7.1
           CLOSE APPBCT.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'gricgger'.
           COPY 'griclfer'.
           COPY 'grifater'.
           COPY 'gritaber'.
      **** rel 7.1
           COPY 'griacter'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSCLI RAGBOL.
           CLOSE WDSCLI RAGBOL.
           OPEN I-O   ANAAZI
                      WDSCLI
                      RAGBOL
                      TABELL.
           OPEN INPUT BOLCTE
                      BOLCRI
                      ANACLF
      **** rel 7.1
                      APPBCT
      ************
                      CAMGIO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
           MOVE 25        TO T25-TIP.
           MOVE IF-AZI    TO T25-COD.
           MOVE '0'       TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-DUP TO DTAIVA.
           MOVE 2 TO TIPOP1.
           MOVE DTAIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATIVB.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA  TO IF-DTFAT.
           MOVE ZERO    TO IF-CLI-1
                           IF-CLI-2
                           IF-BOL-1
                           IF-BOL-2
                           IF-TNU-1
                           IF-TNU-2
                           IF-TPFT.
           MOVE SPACE   TO IF-CLI-1-D
                           IF-CLI-2-D.
           MOVE 15      TO IF-GGESC.
       INI-CAMPI-10.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.         
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO INI-CAMPI-10.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE AZI-FLGIS TO IF-FLGIS.
           IF AZI-FLGIS NOT = 1
              MOVE ZERO TO OLD-FTSOS
                           IF-FTSOS
              GO TO LNOFTS.
           MOVE 23        TO T23-TIP.
           MOVE KAZ-COD   TO T23-COD.
           MOVE T23-KEYID TO KEYTB.
           READ TABELL INTO REKT23 INVALID KEY
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT23.
           MOVE T23-FTSOS TO IF-FTSOS
                             OLD-FTSOS.
       LNOFTS.    
           IF IF-CATT = '0'
              MOVE AZI-NUMFT TO OLD-ULTFAT
              GO TO LPNFA1.
           MOVE 35        TO T35-TIP.
           MOVE KAZ-COD   TO T35-CDAZ.
           MOVE IF-CATT   TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-NUMFT TO OLD-ULTFAT.
       LPNFA1.    
           MOVE OLD-ULTFAT TO IF-ULTFAT.
           MOVE AZI-NEFF   TO OLD-ULTEF
                              IF-ULTEF.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CLI-1.
           MOVE 'IF-CLI-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI-1.
           MOVE IF-CLI-1 TO COD.
           MOVE CODCLI   TO KCF-COD.
           MOVE KAZ-COD  TO KCF-AZI.
           READ ANACLF INVALID MOVE SPACE TO CLF-RGS.
           MOVE CLF-RGS TO IF-CLI-1-D.
       E-CLI-1.
      *
       V-CLI-2.
           MOVE 'IF-CLI-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI-2.
           MOVE IF-CLI-2 TO COD.
           MOVE CODCLI   TO KCF-COD.
           MOVE KAZ-COD  TO KCF-AZI.
           READ ANACLF INVALID MOVE SPACE TO CLF-RGS.
           MOVE CLF-RGS TO IF-CLI-2-D.
      **** rel 3.0
      *    IF FUN NOT = 'V'
           IF FUN = 'V'
      ************
              IF IF-CLI-2 = ZERO MOVE 99999 TO IF-CLI-2.
           IF IF-CLI-2 < IF-CLI-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CLI-2.
      *
       V-BOL-2.
           MOVE 'IF-BOL-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-BOL-2.
      **** rel 3.0
      *    IF FUN NOT = 'V'
           IF FUN = 'V'
      ************
              IF IF-BOL-2 = ZERO MOVE 99999 TO IF-BOL-2.
           IF IF-BOL-2 < IF-BOL-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-BOL-2.
      *
       V-TNU-1.
           MOVE 'IF-TNU-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TNU-1.
           IF IF-TNU-1 > 6
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-TNU-1.
      *
       V-TNU-2.
           MOVE 'IF-TNU-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TNU-2.
           IF IF-TNU-2 > 6
              PERFORM ERR-DINV
              GO TO V-ERROR.
      **** rel 3.0
      *    IF FUN NOT = 'V'
           IF FUN = 'V'
      ************
              IF IF-TNU-2 = ZERO MOVE 6 TO IF-TNU-2.
           IF IF-TNU-2 < IF-TNU-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-TNU-2.
      *
       V-DTFAT.
           MOVE 'IF-DTFAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTFAT.
           IF IF-DTFAT = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTFAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG NOT > DTAIVA 
              MOVE SPACE TO MESS
              STRING 'Totali IVA aggiornati al ' DATIVB   
                     DELIMITED SIZE INTO MESS
                     GO TO V-ERROR.
       E-DTFAT.
      *
       V-TPFT.
           MOVE 'IF-TPFT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPFT.
           IF NOT (IF-TPFT = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPFT.
      *
       V-GGESC.
           MOVE 'IF-GGESC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GGESC.
           IF IF-GGESC > 31 OR IF-GGESC = ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-GGESC.
      *
       V-ULTFAT.
           MOVE 'IF-ULTFAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ULTFAT.
           IF IF-ULTFAT < OLD-ULTFAT 
              MOVE "Numero fattura inferiore"  TO F-MES1
              MOVE "all'ultima fattura emessa" TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
       E-ULTFAT.
      *
       V-ULTEF.
           MOVE 'IF-ULTEF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ULTEF.
           IF IF-ULTEF < OLD-ULTEF 
              MOVE "Effetto inferiore all'ultimo emesso"  TO MESS
              GO TO V-ERROR.
       E-ULTEF.
      *
       V-FTSOS.
           MOVE 'IF-FTSOS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FTSOS.
           IF AZI-FLGIS = 1 GO TO E-FTSOS.
           IF IF-FTSOS < OLD-FTSOS 
              MOVE "Numero fattura inferiore"  TO F-MES1
              MOVE "all'ultima fattura emessa" TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
       E-FTSOS.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           IF FUN = 'B' GO TO RUN-RIENTRO.
      *
           IF AZI-FLGIS = 1
              MOVE IF-FTSOS TO T23-FTSOS
              REWRITE RF-TAB FROM REKT23 INVALID
                      PERFORM INVK-TAB
                      GO TO ERRIO.
           IF IF-CATT NOT = '0'
              MOVE IF-ULTFAT TO T35-NUMFT
              REWRITE RF-TAB FROM REKT35 INVALID
                      PERFORM INVK-TAB
                      GO TO ERRIO.
           MOVE IF-ULTEF TO AZI-NEFF.
           IF IF-CATT = '0' MOVE IF-ULTFAT TO AZI-NUMFT.
           REWRITE RF-AZI FROM REKAZI INVALID
                   PERFORM INVK-AZI
                   GO TO ERRIO.
           UNLOCK ANAAZI.
     *
           MOVE IF-DTFAT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DTFATPK.
     *
           MOVE LOW-VALUE TO KEYRB.
           START RAGBOL KEY > KEYRB INVALID GO TO STCLI.
           MOVE 'RAGBOL non vuoto' TO MESS.
           GO TO ERRIO.
       STCLI.
           MOVE LOW-VALUE TO KEYCL.
           START WDSCLI KEY > KEYCL INVALID GO TO INIZ.
           CLOSE WDSCLI.
           MOVE 'WDSCLI non vuoto' TO MESS.
           GO TO ERRIO.
       INIZ.
           MOVE KAZ-COD  TO KBC-AZI.
           MOVE IF-TNU-1 TO KBC-NUM.
       LP10.
           MOVE IF-BOL-1 TO KBC-BOL.
       RDBOL.
           START BOLCTE KEY NOT < KEYBC INVALID GO TO LPINI.
       L9D.
           READ BOLCTE NEXT AT END GO TO LPINI.
           IF SF-BCT = '9D' OR '9A' OR '35' GO TO L9D.
           IF KBC-AZI > KAZ-COD  GO TO LPINI.
           IF KBC-NUM > IF-TNU-2 GO TO LPINI.
           IF KBC-BOL < IF-BOL-1 GO TO LP10.
           IF KBC-BOL > IF-BOL-2
              ADD 1 TO KBC-NUM
              GO TO LP10.
           IF BCT-CLI < IF-CLI-1 OR > IF-CLI-2 GO TO L9D.
           IF BCT-FLGFT = 1 GO TO L9D.
           IF BCT-DATA > DTFATPK GO TO L9D.
           IF BCT-VALUT > ZERO AND IF-TPFT = ZERO GO TO L9D.
           IF BCT-VALUT < 1    AND IF-TPFT = 1    GO TO L9D.
           IF BCT-CATT NOT = IF-CATT GO TO L9D.
      **** rel 2.0
           IF BCT-ESCFAT = 1 GO TO L9D.
      ************
           MOVE KBC-AZI TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE ZERO    TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO L9D.
       L9E.
           READ BOLCRI NEXT AT END GO TO L9D.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO L9E.
           IF KCR-AZI NOT = KBC-AZI OR
              KCR-NUM NOT = KBC-NUM OR
              KCR-BOL NOT = KBC-BOL GO TO L9D.
           IF BCR-TCOR = 1 GO TO L9E.
           MOVE KBC-AZI   TO KRB-AZI KCL-AZI.
           MOVE BCT-CLI   TO KRB-CLI KCL-CLI.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           READ APPBCT INVALID 
                MOVE ZERO  TO ACT-TIPO
                MOVE SPACE TO ACT-IPA ACT-CIG ACT-CUP.
           MOVE ACT-TIPO  TO KRB-TIPO.
           MOVE ACT-IPA   TO KRB-IPA.
           MOVE ACT-CIG   TO KRB-CIG.
           MOVE ACT-CUP   TO KRB-CUP.
      ************
           MOVE BCT-RAGGR TO KRB-RAGGR.
           MOVE BCT-TDOC  TO KRB-TDOC.
           IF AZI-FLGIS = ZERO MOVE ZERO TO FLGIS
                          ELSE MOVE BCT-FLGIS TO FLGIS.
           IF FLGIS = 1 ADD 3 TO KRB-TDOC.
           MOVE BCT-VALUT TO KRB-VALUT.
           MOVE BCT-CPAG  TO KRB-CPAG.
           MOVE BCT-CBAN  TO KRB-CBAN.
           MOVE BCT-CAGE  TO KRB-CAGE.
           MOVE BCT-SCBAS TO KRB-SCBAS.
           MOVE BCT-ESIVA TO KRB-ESIVA.
      **** rel 6.1
           MOVE BCT-PBASE TO KRB-PBASE.
           MOVE BCT-PRACC TO KRB-PRACC.
      ************
           MOVE ZERO      TO KRB-NORD.
           MOVE KBC-NUM   TO KRB-TNUM.
           MOVE KBC-BOL   TO KRB-NBOL.
           READ WDSCLI INVALID KEY GO TO WRCLI.
           IF KRB-RAGGR = 1
              MOVE CLI-TNUM TO KRB-NUM
              MOVE CLI-NBOL TO KRB-BOL
           ELSE
              MOVE KBC-NUM TO KRB-NUM
              MOVE KBC-BOL TO KRB-BOL.
       WRRGB.
           WRITE RF-RGB INVALID KEY MOVE 'WR RGB' TO MESS GO TO ERRIO.
           GO TO L9D.
       WRCLI.
           MOVE KBC-NUM TO CLI-TNUM KRB-NUM.
           MOVE KBC-BOL TO CLI-NBOL KRB-BOL.
           WRITE RF-CLI INVALID KEY MOVE 'WR CLI' TO MESS GO TO ERRIO.
           GO TO WRRGB.
       LPINI.
           MOVE LOW-VALUE TO KEYCL.
           START WDSCLI KEY > KEYCL INVALID GO TO LPIN2.
       LPIN1.
           READ WDSCLI NEXT AT END GO TO LPIN2.
           IF SF-CLI = '9D' OR '9A' OR '35' GO TO LPIN1.
           DELETE WDSCLI.
           GO TO LPIN1.
       LPIN2.
           CLOSE WDSCLI.
           MOVE KAZ-COD TO CF-AZI.
           MOVE IF-GGESC TO CF-GGESC.
           MOVE DTFATPK  TO CF-DTFAT.
           MOVE ZERO     TO CF-NUMFAT.
           MOVE ZERO     TO CF-SIMUL.
           MOVE ZERO     TO CF-ST.
           MOVE IF-CATT  TO CF-ATTIV.
           MOVE 1        TO CF-VIDEO.
       RDRAG.
      **** rel 1.2
      *    MOVE ZERO TO K.
      *RDRA0.
      *    ADD 1 TO K.
      *    MOVE ZERO TO CF-VTNUM (K) CF-VNBOL (K).
      *    IF K < 15 GO TO RDRA0.
           MOVE 1 TO K.
           PERFORM UNTIL K > RB-MAXBOL
              MOVE ZERO TO RB-TNUM(K)
                           RB-NBOL(K)
              ADD 1 TO K
           END-PERFORM.
      ************
           MOVE ZERO TO K.
           MOVE SPACE TO COMROT.
           MOVE ZERO TO KEYRB.
           MOVE ZERO TO KRB-CLI  KRB-CBAN  KRB-CPAG
                        KRB-CAGE KRB-ESIVA KRB-NORD KRB-BOL.
      **** rel 6.3
           MOVE ZERO TO KRB-IFAT.
      ************
      **** rel 6.1
           MOVE ZERO TO KRB-PBASE KRB-PRACC.
      ************
           MOVE KAZ-COD TO KRB-AZI.
           START RAGBOL KEY NOT < KEYRB INVALID GO TO CALFAT.
       BTNEXT.
           READ RAGBOL NEXT AT END GO TO CALFAT.
           IF SF-RGB = '9D' OR '9A' OR '35' GO TO BTNEXT.
           IF COMROT = SPACE MOVE KRB-ROTT TO COMROT.
           IF KRB-ROTT NOT = COMROT GO TO CALFAT.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO CALFAT.
      *    MOVE KRB-TNUM TO CF-VTNUM (K).
      *    MOVE KRB-NBOL TO CF-VNBOL (K).
           IF K > RB-MAXBOL GO TO CALFAT.
           MOVE KRB-TNUM TO RB-TNUM (K).
           MOVE KRB-NBOL TO RB-NBOL (K).
           MOVE K TO RB-ULTBOL.
      ************
           DELETE RAGBOL.
           IF KRB-RAGGR = ZERO GO TO CALFAT.
           GO TO BTNEXT.
       CALFAT.
           IF K = ZERO GO TO EX-RUN-ELABORA.
      *
      * verifica se bolla con data 1a scadenza da input
           MOVE IF-AZI      TO KBC-AZI.
      **** rel 1.2
      *    MOVE CF-VTNUM(1) TO KBC-NUM.
      *    MOVE CF-VNBOL(1) TO KBC-BOL.
           MOVE RB-TNUM(1) TO KBC-NUM.
           MOVE RB-NBOL(1) TO KBC-BOL.
      ************
           READ BOLCTE INVALID PERFORM INVK-BCT
                               GO TO ERRIO.

           MOVE 4        TO KTB-TIP.
           MOVE BCT-CPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               PERFORM VISK-BCT
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-1SCAD NOT = 5 GO TO CALFAT-10.
      *
      * richiesta ad interfaccia data 1a scadenza
           MOVE SPACE TO F-MES1.
           STRING 'Bolla numero ' KBC-NUM '/' KBC-BOL
                  DELIMITED SIZE INTO F-MES1.
           MOVE 'Inserire la data 1a scadenza' TO F-MES2.
           MOVE 2 TO F-NMES.
           PERFORM ERRIO-MSG THRU EX-ERRIO-MSG.
           GO TO CALFAT-05.
      *
      * label di rientro nel caso di data 1a scadenza da input
       RUN-RIENTRO.
      *
      * richiesta data prima scadenza
           MOVE ZERO TO CF-DT1SCA.
           MOVE IF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 4.0
           IF SWRET1 = ZERO
              IF AAGGG < DTFATPK
                 MOVE 'Data < data fattura' TO MESS
                 PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                 GO TO CALFAT-05.
      ************
           IF SWRET1 = ZERO MOVE AAGGG TO CF-DT1SCA
                            GO TO CALFAT-10.
           MOVE 'Data errata' TO MESS.
           PERFORM ERRIO-MSG THRU EX-ERRIO-MSG.
       CALFAT-05.
      * rimanda a interfaccia inserimento data 1a scadenza
           MOVE 2 TO IF-ST.
           GO TO EX-RUN-ELABORA.
       CALFAT-10.
      *
      **** rel 1.2
      *    CALL 'vfat190' USING PARCF RF-FAT.
           CALL 'vfat190' USING PARCF PARRB RF-FAT.
      ************
           CANCEL 'vfat190'.
           IF CF-ST = ZERO GO TO RDRAG.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-CLI ID-RGB.
           STRING 'w1' PID DELIMITED SPACE INTO ID-CLI.
           STRING 'w2' PID DELIMITED SPACE INTO ID-RGB.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
