       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORD160.
      *
      * OGGETTO: Eliminazione ordini evasi
      *
      **** rel 6.1
      * spostata cancellazione archivi collegati in VRDLORD e VRDLRIG
      * tolti commenti release precedenti
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griordsl'.
           COPY 'gririgsl'.
           COPY 'griazisl'.
      **** rel 7.1
           COPY 'griaorsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griord'.
           COPY 'gririg'.
           COPY 'griazi'.
      **** rel 7.1
           COPY 'griaor'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'griazirk'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'paroc'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
      **** rel 7.1
       01  ID-AOR PIC X(15) VALUE 'appord'.
      ************
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-ORD   PIC XX.
           05 SF-RIG   PIC XX.
      **** rel 7.1
           05 SF-AOR  PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DATA1    PIC 9(5) COMP-3.
           05 DATA2    PIC 9(5) COMP-3.
      **** rel 6.1
       01  PARDOW.
           05 DOW-FUN   PIC X.
           05 DOW-AZI   PIC 9(5).
           05 DOW-DANUM PIC 9(5).
           05 DOW-ANUM  PIC 9(5).
           05 DOW-DADAT PIC 9(5).
           05 DOW-ADAT  PIC 9(5).
           05 FILLER    PIC X(10).
      ************
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclord'.
           COPY 'dclrig'.
      **** rel 7.1
           COPY 'dclaor'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vord160: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI ORDCLI ORDRIG.
      **** rel 7.1
           CLOSE APPORD.
      ************
      **** rel 6.1
           MOVE ZERO   TO PARDOW.
           MOVE 'C'    TO DOW-FUN.
           MOVE IF-AZI TO DOW-AZI.
           CALL 'rdelorw' USING PARDOW IF-MESS.
           IF ERRIO-ST > ZERO GO TO ERRIO.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griorder'.
           COPY 'gririger'.
      **** rel 7.1
           COPY 'griaorer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           OPEN I-O ORDCLI ORDRIG.
      **** rel 7.1
           OPEN I-O APPORD.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO TO IF-COD-1
                        IF-COD-2.
           MOVE ZERO TO IF-DATA-1
                        IF-DATA-2
                        DATA1
                        DATA2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           IF IF-DATA-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATA1.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATA2.
           IF DATA2 < DATA1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           MOVE KAZ-COD  TO KOR-AZI.
           MOVE IF-COD-1 TO KOR-NUM.
           START ORDCLI KEY NOT < KEYOR INVALID GO TO EX-RUN-ELABORA.
       RDCLI.
           READ ORDCLI NEXT INTO REKORD AT END GO TO EX-RUN-ELABORA.
           IF SF-ORD = '9D' OR '9A' OR '35' GO TO RDCLI.
           IF ORD-AZI > KAZ-COD GO TO EX-RUN-ELABORA.
           IF ORD-NUM > IF-COD-2 GO TO EX-RUN-ELABORA.
           IF ORD-DAT < DATA1 OR > DATA2 GO TO RDCLI.
      *
           MOVE KOR-AZI TO OC-AZI.
           MOVE KOR-NUM TO OC-NUM.
           CALL 'vrvopc' USING PAROC.
      *
           MOVE ORD-KEYID TO KEYRI.
           MOVE ZERO      TO KRI-PRG.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO DLRIG.
       RDRIG.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO DLRIG.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO RDRIG.
           IF RIG-AZI > ORD-AZI GO TO DLRIG.
           IF RIG-NUM > ORD-NUM GO TO DLRIG.
           IF RIG-TPRIG = 1 OR 3 GO TO RDRIG.
           IF OC-FLG = 1
              IF RIG-QUANT - RIG-QSPED > ZERO
                 GO TO RDCLI
              ELSE
                 GO TO RDRIG.
           IF RIG-SALDO = ZERO GO TO RDCLI.
           GO TO RDRIG.
       DLRIG.
           MOVE ORD-KEYID TO KEYRI.
           MOVE ZERO TO KRI-PRG.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO DLTES.
       LPDEL.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO DLTES.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO LPDEL.
           IF RIG-AZI > ORD-AZI GO TO DLTES.
           IF RIG-NUM > ORD-NUM GO TO DLTES.

      **** rel 6.1
           CALL 'vrdlrig' USING KEYRI.
      ************

           DELETE ORDRIG INVALID PERFORM INVK-RIG
                                 GO TO ERRIO.
           CALL 'vrdlopc' USING KEYRI.
           GO TO LPDEL.
       DLTES.
      **** rel 6.1
           CALL 'vrdlord' USING KEYOR.
      ************
      *
           DELETE ORDCLI INVALID PERFORM INVK-ORD
                                 GO TO ERRIO.
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           READ APPORD INVALID GO TO NOAOR.
           DELETE APPORD INVALID PERFORM INVK-AOR
                                 GO TO ERRIO.
       NOAOR.
      ************
           GO TO RDCLI.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
