       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGATT. 
      *
      *    Interfaccia TABELL per scheda Anagrafico Attivita' (T35)
      *
      **** rel 4.0
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
       01  RELPRIMULA.
           05 FILLER PIC X(50) VALUE
              '@(#)Primula NT rel 5.0     GR Informatica'.
           05 FILLER PIC X     VALUE LOW-VALUE.
           COPY 'grit35rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 7.1
           COPY 'parmb'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-TIP   PIC 99.
           05 IF-AZI   PIC 9(3).
       LINKAGE SECTION.
           COPY 'grit35rg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-T35-CTRL
                                RG-T35-REC
                                RA-T35-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-T35-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-T35-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-T35-FUN   TO FUN.
           MOVE 1            TO IDX.
           MOVE RG-T35-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-T35-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgatt: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-T35-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-T35-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-T35-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK TABELL.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-TAB INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-TAB INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
           UNLOCK TABELL.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-TAB
              GO TO WARNING.
           IF RG-T35-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE TABELL INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
           UNLOCK TABELL.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-T35-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK TABELL.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-T35-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-T35-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-T35-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           IF RG-T35-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB.
           OPEN INPUT ANAAZI.
           OPEN I-O TABELL.
      *
           MOVE RG-T35-CDAZ TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-T35-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO  TO RF-TAB REKT35.
           MOVE SPACE TO T35-CATT
                         T35-DATT.
           MOVE ZERO  TO T35-CDAZ
                         T35-RVNRG
                         T35-NUMFT
                         T35-RANRG
                         T35-PRCOR
                         T35-DTR
                         T35-UNR.
      *
           MOVE REKT35 TO RF-TAB.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-T35-TIP  TO IF-TIP.
           MOVE RG-T35-CDAZ TO IF-AZI.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-T35-REC.
           MOVE SPACE TO RG-T35-CATT
                         RG-T35-DATT.
           MOVE ZERO  TO RA-T35-AGG.
           MOVE SPACE TO RA-T35-AZI-D.

      * ripristino dei campi chiave fissi
           MOVE IF-TIP TO RG-T35-TIP.
           MOVE IF-AZI TO RG-T35-CDAZ.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE AZRGSOC TO RA-T35-AZI-D.
           MOVE 1 TO RG-T35-TPL.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-T35-TIP  TO T35-TIP.
           MOVE RG-T35-CDAZ TO T35-CDAZ.
           MOVE RG-T35-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           MOVE KEYTB TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYTB.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ TABELL INTO REKT35 INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ TABELL INTO REKT35 KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-TAB > ZERO MOVE 7 TO RG-T35-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ TABELL PREVIOUS INTO REKT35 AT END MOVE 1 TO EOF
           ELSE
              READ TABELL NEXT INTO REKT35 AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-TAB = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-T35-EOF.
           MOVE KEYTB TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-T35-EOF.
           IF RG-T35-EOF = 4 MOVE 2 TO RG-T35-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-TAB = LOW-VALUE GO TO EX-TEST-EOL.
           IF T35-TIP  = RG-T35-TIP  AND
              T35-CDAZ = RG-T35-CDAZ GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-T35-TIP        TO T35-TIP.
           MOVE RG-T35-CDAZ       TO T35-CDAZ.
           MOVE RG-T35-CATT       TO T35-CATT.
           MOVE RG-T35-DATT       TO T35-DATT.
           MOVE RG-T35-RVNRG      TO T35-RVNRG.
           MOVE RG-T35-NUMFT      TO T35-NUMFT.
           MOVE RG-T35-RANRG      TO T35-RANRG.
           MOVE RG-T35-PRCOR      TO T35-PRCOR.
           MOVE RG-T35-RICAV      TO T35-RICAV.
           MOVE RG-T35-TIG        TO T35-TIG.
           MOVE RG-T35-TRI        TO T35-TRI.
           MOVE RG-T35-DTP        TO T35-DTP.
           MOVE RG-T35-PRI        TO T35-PRI.
      **** rel 4.1a
           MOVE RG-T35-FLST       TO T35-FLST.
      ************
      **** rel 7.1
           MOVE RG-T35-FELE       TO T35-FELE.
      ************
           MOVE RG-T35-GES        TO T35-GES.
           MOVE RG-T35-TPL        TO T35-TPL.
           MOVE RG-T35-UNR        TO T35-UNR.
           MOVE RG-T35-DTR TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO T35-DTR.
           MOVE REKT35 TO RF-TAB.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE T35-TIP       TO RG-T35-TIP.
           MOVE T35-CDAZ      TO RG-T35-CDAZ.
           MOVE T35-CATT      TO RG-T35-CATT.
           MOVE T35-DATT      TO RG-T35-DATT.
           MOVE T35-RVNRG     TO RG-T35-RVNRG.
           MOVE T35-NUMFT     TO RG-T35-NUMFT.
           MOVE T35-RANRG     TO RG-T35-RANRG.
           MOVE T35-PRCOR     TO RG-T35-PRCOR.
           MOVE T35-RICAV     TO RG-T35-RICAV.
           MOVE T35-TIG       TO RG-T35-TIG.
           MOVE T35-TRI       TO RG-T35-TRI.
           MOVE T35-DTP       TO RG-T35-DTP.
           MOVE T35-PRI       TO RG-T35-PRI.
      **** rel 4.1a
           MOVE T35-FLST      TO RG-T35-FLST.
      ************
      **** rel 7.1
           MOVE T35-FELE      TO RG-T35-FELE.
      ************
           MOVE T35-GES       TO RG-T35-GES.
           MOVE T35-TPL       TO RG-T35-TPL.
           IF RG-T35-TPL = ZERO MOVE 1 TO RG-T35-TPL.
           MOVE T35-UNR       TO RG-T35-UNR.
           MOVE T35-DTR TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-T35-DTR.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE AZRGSOC TO RA-T35-AZI-D.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-T35-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-CATT.
           MOVE 'T35-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF RG-T35-CATT = '0' OR SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 4.0-2
           IF RG-T35-CATT NOT NUMERIC
              PERFORM ERR-DINV
              GO TO V-ERROR.
      ************
      **** rel 7.1
           IF RG-T35-CATT = 9
              MOVE 'Causale 9 non presentabile per' TO F-MES1
              MOVE 'registri acquisti/vendite'     TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB.
      ************
       E-CATT.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-T35-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATT.
           MOVE 'T35-DATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATT.
           IF RG-T35-DATT = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-DATT.
      *
       V-DTR.
           MOVE 'T35-DTR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTR.
           MOVE 1 TO TIPOP1.
           MOVE RG-T35-DTR TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTR.
      *
       V-GES.
           MOVE 'T35-GES' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GES.
           IF NOT (RG-T35-GES = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF RG-T35-GES = ZERO
              MOVE ZERO TO RG-T35-TIG
                           RG-T35-TRI
                           RG-T35-DTP
                           RG-T35-PRI
      **** rel 4.1a
                           RG-T35-FLST
      ************
              MOVE 1    TO RG-T35-TPL.
       E-GES.
      *
       V-TIG.
           MOVE 'T35-TIG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIG.
           IF NOT (RG-T35-TIG = ZERO OR 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TIG.
      *
       V-TPL.
           MOVE 'T35-TPL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPL.
           IF NOT (RG-T35-TPL = 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF RG-T35-TPL > 1 MOVE ZERO TO RG-T35-TRI.
       E-TPL.
      *
       V-TRI.
           MOVE 'T35-TRI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TRI.
           IF RG-T35-TRI > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-TRI.
      *
      **** rel 7.1
       V-FELE.
           MOVE 'T35-FELE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FELE.
           IF RG-T35-FELE = 1
              IF RG-T35-CATT = '0' OR SPACE
                 MOVE ZERO TO RG-T35-FELE
                 MOVE 'Fatture elettroniche non gestibili' TO F-MES1
                 MOVE 'su attivit principale.           ' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO V-ERROR.
       E-FELE.
      *
      ************
       V-DTPMM.
           MOVE 'T35-DTPMM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTPMM.
           IF RG-T35-DTPMM > 12
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-DTPMM.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
