       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGT04. 
      *
      *    Interfaccia TABELL per scheda 04 pagamenti
      *
      **** rel 4.0
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      **** rel 6.0
           COPY 'grintasl'.
      ************
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gritab'.
      **** rel 6.0
           COPY 'grinta'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
      **** rel 7.2
           COPY 'grit50rk'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 6.0
           COPY 'parml'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
      **** rel 6.0
       01  ID-NTA PIC X(15) VALUE 'nottab'.
      *---------------------------------------------------
      * costanti
      *    NRIGMAX: n. righe max note 
       78  NRIGMAX  VALUE 20.
      *---------------------------------------------------
      ************
       01  COMODI.
           05 SF-TAB   PIC XX.
      **** rel 6.0
           05 SF-NTA   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-TIP   PIC 99.
      **** rel 6.0
           05 KML      PIC 9(5).
           05 KVALID   PIC 9(5).
           05 KN       PIC 9(5).
           05 MAXRIGD  PIC ZZ9.
           05 K        PIC 9(2).
      ************
       LINKAGE SECTION.
           COPY 'grit04rg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-T04-CTRL
                                RG-T04-REC
                                RA-T04-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dcltab'.
      **** rel 6.0
           COPY 'dclnta'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-T04-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-T04-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-T04-FUN   TO FUN.
           MOVE RG-T04-IDX   TO IDX.
           MOVE RG-T04-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-T04-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgt04: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-T04-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-T04-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-T04-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK TABELL.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-TAB INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
      **** rel 6.0
       F-SCRIVI-NTA.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-TAB INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
      **** rel 6.0
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
           UNLOCK TABELL.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-TAB
              GO TO WARNING.
           IF RG-T04-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE TABELL INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
      **** rel 6.0
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      ************
           UNLOCK TABELL.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-T04-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK TABELL.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-T04-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
      **** rel 6.0
           CLOSE NOTTAB.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-T04-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-T04-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gritaber'.
      **** rel 6.0
           COPY 'grintaer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           IF RG-T04-FL = ZERO MOVE 'tabell' TO ID-TAB
           ELSE                MOVE 'tabold' TO ID-TAB.
           OPEN I-O TABELL.
      **** rel 6.0
           OPEN I-O NOTTAB.
      ************
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-T04-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-TAB REKTAB.
           MOVE SPACE TO TAB-DESCR. 
      *
           MOVE REKTAB TO RF-TAB.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-T04-TIP TO IF-TIP.
      * azzeramento aree interfaccia
           MOVE ZERO TO RG-T04-REC.
           MOVE SPACE TO RG-T04-DESCR.
           MOVE ZERO TO RA-T04-AGG.
      **** rel 7.2
           MOVE SPACE TO RA-T04-MPAG-D.
      ************
      **** rel 6.0
           PERFORM AZZ-NOTE.
      ************
      * ripristino dei campi chiave fissi
           MOVE IF-TIP TO RG-T04-TIP.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-T04-TIP TO KTB-TIP.
           MOVE RG-T04-COD TO KTB-COD.
           MOVE KEYTB TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYTB.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ TABELL INTO REKTAB INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ TABELL INTO REKTAB KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-TAB > ZERO MOVE 7 TO RG-T04-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ TABELL PREVIOUS INTO REKTAB AT END MOVE 1 TO EOF
           ELSE
              READ TABELL NEXT INTO REKTAB AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-TAB = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KTB-TIP NOT = RG-T04-TIP GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-T04-EOF.
           MOVE KEYTB TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-T04-EOF.
           IF RG-T04-EOF = 4 MOVE 2 TO RG-T04-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-TAB = LOW-VALUE GO TO EX-TEST-EOL.
           IF KTB-TIP = RG-T04-TIP GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-T04-TIP     TO TAB-TIP.
           MOVE RG-T04-COD     TO TAB-COD.
           MOVE RG-T04-DESCR   TO TAB-DESCR.
           MOVE RG-T04-TIPAG   TO T04-TIPAG.
           MOVE RG-T04-NRATE   TO T04-NRATE.
           MOVE RG-T04-NG1SC   TO T04-NG1SC.
           MOVE RG-T04-NGSSC   TO T04-NGSSC.
           MOVE RG-T04-1SCAD   TO T04-1SCAD.
      **** rel 6.0
      *    MOVE RG-T04-ESCMM   TO T04-ESCMM. 
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE RG-T04-ESCM(K) TO T04-ESCM(K) 
              ADD 1 TO K.
      ************
           MOVE RG-T04-SPESE   TO T04-SPESE.
           MOVE RG-T04-SCASS   TO T04-SCASS.
           IF NOT ( RG-T04-TIPAG = 1 OR 2 )
              MOVE ZERO TO RG-T04-FLGIVA
           ELSE
              IF RG-T04-NRATE = 1 OR ZERO
                 MOVE ZERO TO RG-T04-FLGIVA.
           IF RG-T04-FLGIVA = ZERO
              MOVE ZERO TO RG-T04-NGIVA.
           MOVE RG-T04-FLGIVA  TO T04-FLGIVA.
           MOVE RG-T04-NGIVA   TO T04-NGIVA.
      **** rel 7.1
           MOVE RG-T04-MPAG    TO T04-MPAG.
      ************
           IF RG-T04-TIPAG NOT = 2 MOVE ZERO TO RG-T04-TRIBA.
           MOVE RG-T04-TRIBA TO T04-TRIBA.
           MOVE REKTAB TO RF-TAB.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE TAB-TIP     TO RG-T04-TIP.
           MOVE TAB-COD     TO RG-T04-COD.
           MOVE TAB-DESCR   TO RG-T04-DESCR.
           MOVE T04-TIPAG   TO RG-T04-TIPAG.
           MOVE T04-NRATE   TO RG-T04-NRATE.
           MOVE T04-NG1SC   TO RG-T04-NG1SC.
           MOVE T04-NGSSC   TO RG-T04-NGSSC.
           MOVE T04-1SCAD   TO RG-T04-1SCAD.
      **** rel 6.0
      *    MOVE T04-ESCMM   TO RG-T04-ESCMM.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE T04-ESCM(K) TO RG-T04-ESCM(K) 
              ADD 1 TO K.
      ************
           MOVE T04-SPESE   TO RG-T04-SPESE.
           MOVE T04-SCASS   TO RG-T04-SCASS.
           MOVE T04-FLGIVA  TO RG-T04-FLGIVA.
           MOVE T04-NGIVA   TO RG-T04-NGIVA.
           MOVE T04-TRIBA   TO RG-T04-TRIBA.
      **** rel 7.1
           MOVE T04-MPAG    TO RG-T04-MPAG.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
      **** rel 6.0
           PERFORM RD-NTA THRU EX-RD-NTA.
      ************
      **** rel 7.2
           MOVE 50          TO KTB-TIP.
           MOVE RG-T04-MPAG TO KTB-COD.
           READ TABELL INTO REKT50 INVALID MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RA-T04-MPAG-D.
      *
           MOVE RG-T04-TIP TO KTB-TIP.
           MOVE RG-T04-COD TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                GO TO ERRIO.
      ************
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-T04-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-COD.
           MOVE 'T04-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD.
           IF RG-T04-COD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-COD.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-T04-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DESCR.
           MOVE 'T04-DESCR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DESCR.
           IF RG-T04-DESCR = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-DESCR.
      *
       V-TIPAG.
           MOVE 'T04-TIPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPAG.
           IF RG-T04-TIPAG NOT NUMERIC OR 
              RG-T04-TIPAG = ZERO OR 7 OR 8
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF NOT ( RG-T04-TIPAG = 1 OR 2 ) MOVE ZERO TO 
                    RG-T04-FLGIVA RG-T04-NGIVA.
       E-TIPAG.
      *
      **** rel 7.1
       V-MPAG.
           MOVE 'T04-MPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-MPAG.
      **** rel 7.2
      *    IF RG-T04-MPAG NOT NUMERIC
      *       PERFORM ERR-DINV
      *       GO TO V-ERROR.
           IF RG-T04-MPAG = ZERO
              MOVE SPACE TO RA-T04-MPAG-D
              GO TO E-MPAG.
           MOVE 50          TO KTB-TIP.
           MOVE RG-T04-MPAG TO KTB-COD.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RA-T04-MPAG-D.
      *
           MOVE RG-T04-TIP TO KTB-TIP.
           MOVE RG-T04-COD TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                GO TO ERRIO.
      ************
       E-MPAG.
      *
      ************
       V-NRATE.
           MOVE 'T04-NRATE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NRATE.
      **** rel 6.0
      *    IF RG-T04-NRATE < 1 OR > 6
      **** rel 6.2
      *    IF RG-T04-NRATE < 1 OR > 12
           IF RG-T04-NRATE > 12
      ************
              PERFORM ERR-DINV
              GO TO V-ERROR.
      **** rel 3.0a
      *    IF RG-T04-TIPAG = 1 OR 2 AND RG-T04-NRATE = 1 OR ZERO 
           IF (RG-T04-TIPAG = 1 OR 2) AND (RG-T04-NRATE = 1 OR ZERO)
      *************
              MOVE ZERO TO RG-T04-FLGIVA RG-T04-NGIVA.
       E-NRATE.
      *
       V-1SCAD.
           MOVE 'T04-1SCAD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-1SCAD.
           IF RG-T04-1SCAD NOT NUMERIC
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-1SCAD.
      *
      **** rel 6.0
      *V-ESCMM.
      *    MOVE 'T04-ESCMM' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ESCMM.
      *    IF RG-T04-ESCMM NOT NUMERIC
      *       PERFORM ERR-DINV
      *       GO TO V-ERROR.
      *E-ESCMM.
      *
      ************
       V-FLGIVA.
           MOVE 'T04-FLGIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGIVA.
           IF RG-T04-FLGIVA NOT NUMERIC OR
              RG-T04-FLGIVA > 2
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF RG-T04-FLGIVA = ZERO
              MOVE ZERO TO RG-T04-NGIVA.
       E-FLGIVA.
      *
       V-TRIBA.
           MOVE 'T04-TRIBA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TRIBA.
           IF RG-T04-TRIBA NOT NUMERIC
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF RG-T04-TRIBA > 2
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-TRIBA.
      *
       V-NGIVA.
           MOVE 'T04-NGIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NGIVA.
           IF RG-T04-TRIBA NOT = 1 GO TO E-NGIVA.
           IF RG-T04-NGIVA NOT < RG-T04-NG1SC
              MOVE " N. giorni < n. giorni 1a scadenza" TO MESS
              GO TO V-ERROR.
       E-NGIVA.
      **** rel 6.0
      *
       V-NOTE.
           MOVE 'T04-NOTE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOTE.
           MOVE NRIGMAX TO ML-MAXRIG.
           MOVE 30      TO ML-LUNRIG.
           MOVE 0       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-T04-NOTE.
           IF ML-ST = 1
              MOVE SPACE TO F-MES2
              MOVE 'E'' possibile caricare' TO F-MES1
              MOVE NRIGMAX TO MAXRIGD
              STRING 'al massimo ' MAXRIGD ' righe'
                     DELIMITED SIZE INTO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
       E-NOTE.
      ************
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
      **** rel 6.0
      * cancellazione note aggiuntive
       DL-NOTE.
           MOVE TAB-TIP TO KNTA-TIP.
           MOVE TAB-COD TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
      *
           START NOTTAB KEY >= KEYNTA INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOTTAB NEXT AT END GO TO EX-DL-NOTE.
           IF KNTA-TIP > TAB-TIP GO TO EX-DL-NOTE.
           IF KNTA-COD > TAB-COD GO TO EX-DL-NOTE.
           DELETE NOTTAB INVALID PERFORM INVK-NTA
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
      * fase di scrittura note
       DL-WR-NOTE.
      *
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      *
       WR-NOTE.
           MOVE NRIGMAX  TO ML-MAXRIG.
           MOVE 30       TO ML-LUNRIG.
           MOVE 1        TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-T04-NOTE.
      *
           IF RA-T04-NOTE = SPACE GO TO EX-DL-WR-NOTE.
      *
           MOVE NRIGMAX  TO KVALID.
           PERFORM UNTIL RA-T04-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
      *
           MOVE TAB-TIP TO KNTA-TIP.
           MOVE TAB-COD TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
      *
           MOVE 1 TO KML.
           PERFORM UNTIL KML > KVALID
              ADD 1 TO KNTA-PRG
              MOVE RA-T04-RIGNOT(KML) TO NTA-DESCR
              WRITE RF-NTA INVALID PERFORM INVK-NTA
                                   GO TO ERRIO
              END-WRITE
              ADD 1 TO KML
           END-PERFORM.
      *
       EX-DL-WR-NOTE.
           EXIT.
      *------------------
      * fase di lettura note e caricamento aree interfaccia
       RD-NTA.
           PERFORM AZZ-NOTE.
      *
           MOVE ZERO TO KN.
      *
           MOVE TAB-TIP TO KNTA-TIP.
           MOVE TAB-COD TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO RD-NTA-20.
       RD-NTA-10.
           READ NOTTAB NEXT AT END GO TO RD-NTA-20.
           IF KNTA-TIP > TAB-TIP GO TO RD-NTA-20.
           IF KNTA-COD > TAB-COD GO TO RD-NTA-20.
           ADD 1 TO KN.
           IF KN <= NRIGMAX
              MOVE NTA-DESCR TO RA-T04-RIGNOT(KN).
           GO TO RD-NTA-10.
       RD-NTA-20.
      *
           MOVE NRIGMAX  TO ML-MAXRIG.
           MOVE 30       TO ML-LUNRIG.
           MOVE 2        TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-T04-NOTE.
      *
      * conta nbyte note
      *
           MOVE ZERO TO RA-T04-NBYTE.
           IF RA-T04-NOTE = SPACE GO TO EX-RD-NTA.
      *
           MOVE NRIGMAX TO KVALID.
           PERFORM UNTIL RA-T04-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
      *
           COMPUTE RA-T04-NBYTE = KVALID * 30.
       EX-RD-NTA.
           EXIT.
      *------------------
       AZZ-NOTE.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-T04-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-T04-NBYTE.
      *------------------
      ************
