       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGTFE.
      *
      *    Interfaccia TABFEL per fatture elettroniche
      *
      **** rel 7.1
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritfesl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritfe'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TFE PIC X(15) VALUE 'tabfel'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TFE   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
      * formato del file esportato
           05 COMFOR PIC X(5) VALUE 'SDI11'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  RG-TFE-CTRL.
           05 RG-TFE-AZI   PIC 999.
           05 RG-TFE-FUN   PIC X.
           05 RG-TFE-CAMPO PIC X(20).
           05 RG-TFE-ST    PIC 9.
      *
      * Record di interfaccia
      *
       01  RG-TFE-REC.
           05 RG-TFE-NAZ     PIC X(2).
           05 RG-TFE-CFISC   PIC X(28).
           05 RG-TFE-PROG    PIC 9(10).
           05 RG-TFE-FORM  PIC X(5).
           05 RG-TFE-CNAZ    PIC X(2).
           05 RG-TFE-REGF    PIC X(4).
           05 RG-TFE-UFFICIO PIC X(2).
           05 RG-TFE-NREA    PIC X(20).
           05 RG-TFE-CAPSOC  PIC 9(15).
           05 RG-TFE-SOCUNI  PIC X(2).
           05 RG-TFE-STALIQ  PIC X(2).
           05 RG-TFE-PERC   PIC X(100).
      *
       01  RA-TFE-AGG.
           05 RA-TFE-AZI-D  PIC X(36).
      *
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-TFE-CTRL
                                RG-TFE-REC
                                RA-TFE-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclTFE'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-TFE-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-TFE-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-TFE-FUN   TO FUN.
           MOVE RG-TFE-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'VRGTFE: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-TFE-ST = 7 GO TO FINE.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           UNLOCK TABFEL.
           GO TO F-READ.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           REWRITE RF-TFE INVALID
              PERFORM INVK-TFE
              GO TO ERRIO.
           UNLOCK TABFEL.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-TFE
              GO TO WARNING.
           IF RG-TFE-ST = 7 GO TO FINE.
           DELETE TABFEL INVALID
              PERFORM INVK-TFE
              GO TO ERRIO.
           UNLOCK TABFEL.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-TFE-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK TABFEL.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-TFE-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABFEL.
           CLOSE TABELL.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-TFE-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-TFE-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritfeer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN I-O TABFEL.
      *     
           MOVE RG-TFE-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *         
           PERFORM MOVE-KEY.
           READ TABFEL INVALID
                PERFORM SCRIVI THRU EX-SCRIVI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE KAZ-COD TO KTFE-AZI. 
           MOVE KEYTFE   TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYTFE.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ TABFEL INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ TABFEL KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-TFE > ZERO MOVE 7 TO RG-TFE-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-TFE-AZI     TO KTFE-AZI.
      *
           MOVE RG-TFE-NAZ     TO TFE-NAZ.
           MOVE RG-TFE-CFISC   TO TFE-CFISC.
           MOVE RG-TFE-PROG    TO TFE-PROG.
           MOVE COMFOR         TO TFE-FORM.
           MOVE RG-TFE-CNAZ    TO TFE-CNAZ.
           MOVE RG-TFE-REGF    TO TFE-REGF.
           MOVE RG-TFE-UFFICIO TO TFE-UFFICIO.
           MOVE RG-TFE-NREA    TO TFE-NREA. 
           MOVE RG-TFE-CAPSOC  TO TFE-CAPSOC.
           MOVE RG-TFE-SOCUNI  TO TFE-SOCUNI.
           MOVE RG-TFE-STALIQ  TO TFE-STALIQ.
           MOVE RG-TFE-PERC    TO TFE-PERC.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE TFE-NAZ     TO RG-TFE-NAZ.
           MOVE TFE-CFISC   TO RG-TFE-CFISC.
           MOVE TFE-PROG    TO RG-TFE-PROG.
           MOVE TFE-FORM  TO RG-TFE-FORM.
           MOVE TFE-CNAZ    TO RG-TFE-CNAZ.
           MOVE TFE-REGF    TO RG-TFE-REGF.
           MOVE TFE-UFFICIO TO RG-TFE-UFFICIO.
           MOVE TFE-NREA    TO RG-TFE-NREA. 
           MOVE TFE-CAPSOC  TO RG-TFE-CAPSOC.
           MOVE TFE-SOCUNI  TO RG-TFE-SOCUNI.
           MOVE TFE-STALIQ  TO RG-TFE-STALIQ.
           MOVE TFE-PERC    TO RG-TFE-PERC.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE AZRGSOC TO RA-TFE-AZI-D.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi non chiave (NB: di RG-T30-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TIPPER.
           MOVE 'TFE-TIPPER' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPPER.
       E-TIPPER.
      *
       V-NAZ.
           MOVE 'TFE-NAZ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NAZ.
           IF RG-TFE-NAZ = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NAZ.
      *
       V-CFISC.
           MOVE 'TFE-CFISC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFISC.
           IF RG-TFE-CFISC = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CFISC.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
       SCRIVI.
           MOVE ZERO  TO RF-TFE.
           PERFORM MOVE-KEY.
           MOVE SPACE TO TFE-NAZ TFE-CFISC TFE-CNAZ TFE-REGF TFE-UFFICIO
                         TFE-NREA  TFE-PERC.
           MOVE COMFOR TO TFE-FORM.
           MOVE 'SU' TO TFE-SOCUNI.
           MOVE 'LN' TO TFE-STALIQ.
           WRITE RF-TFE INVALID PERFORM INVK-TFE
                                        GO TO ERRIO.
       EX-SCRIVI.
           EXIT.
      *------------------
