       IDENTIFICATION DIVISION.
       PROGRAM-ID. VUTI191.
      *
      * Stampa clienti/fornitori per fatturato decr. alla data
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV 
                  ALTERNATE RECORD KEY 
                         SKEYLV1 = SKWS-FAT SKWS-COD
                  STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'grimov'.
      *
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 122 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
              05 SKWS-COD.
                 10 KWS-COD PIC 9(5).
           02 WDS-RGS PIC X(36).
           02 WDS-IND PIC X(24).
           02 WDS-CAP PIC 9(5).   
           02 WDS-CIT PIC X(23).
           02 WDS-PRV PIC X(2).
           02 WDS-FAT PIC S9(11)V99.
           02 SKWS-FAT.
              05 KWS-FAT PIC S9(11)V99.
      *
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'grimovrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 PKDT1    PIC 9(5) VALUE ZERO.
           05 PKDT2    PIC 9(5) VALUE ZERO.
           05 MASC     PIC 99 VALUE ZERO.
           05 MASF     PIC 99 VALUE ZERO.
           05 CODCLI   PIC 9(7) VALUE ZERO.
           05 FILLE REDEFINES CODCLI.
               10 MAS PIC 99.
               10 COD PIC 9(5).
           05 TOTFAT   PIC S9(11)V99 VALUE ZERO.
           05 TOTALE   PIC S9(15)V99 VALUE ZERO.
           05 PART1    PIC 9(7).
           05 PART.
              10 MPART PIC 99.
              10 CPART PIC 9(5).
           05 PARTS    PIC 9(7).
           05 CIVAV   PIC 9(7).
           05 CIVAQ   PIC 9(7).
      **** rel 7.2
           05 CIVSO   PIC 9(7).
           05 FLGIS   PIC 9.
      ************
           05 CIVA    PIC 9(7) COMP-3.
           05 NREG    PIC 9(5).
           05 TREG    PIC 9.
           05 IMPON   PIC S9(11)V99.
           05 NIMPO   PIC S9(11)V99.
           05 ESENT   PIC S9(11)V99.
           05 IMIVA   PIC S9(11)V99.
           05 TACCR   PIC S9(11)V99.
           05 NFATT   PIC S9(5).
           05 NOPNI   PIC S9(5).
           05 NACCR   PIC S9(5).
           05 IMP     PIC S9(11)V99.
           05 IVN     PIC S9(11)V99.
           05 IVA     PIC S9(11)V99.
           05 SEGNO   PIC 9.
           05 TIPOP   PIC 99.
           05 CDCORR     PIC 9(7) VALUE ZERO.
      *
         COPY 'vuti191.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-ANNO      PIC 9.
           05 IF-TIPST     PIC 9.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-DAT-1     PIC 9(6).
           05 IF-DAT-2     PIC 9(6).
           05 IF-FATMIN    PIC S9(11)V99.
           05 IF-DATEL     PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dcllav'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vuti191: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.

           OPEN INPUT ANAAZI.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATEL.
      *
           MOVE ZERO   TO IF-COD-1
                          IF-COD-2
                          IF-ANNO
                          IF-TIPST
                          IF-FATMIN
                          IF-DAT-1
                          IF-DAT-2
                          PKDT1 
                          PKDT2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DAT-1.
           MOVE 'IF-DAT-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
       E-DAT-1.
      *
       V-DAT-2.
           MOVE 'IF-DAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT2.
           IF PKDT1 > PKDT2
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DAT-2.
      *
       V-DATA.
           MOVE 'IF-DATEL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATEL TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE AZRGSOC TO TAZI.
      *
           MOVE 1 TO TIPOP1.
           MOVE IF-DATEL TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT.
      *
           IF IF-TIPST = ZERO MOVE 'CLIENTE'   TO TMAS
           ELSE               MOVE 'FORNITORE' TO TMAS.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'LISTA ' TMAS ' PER FATTURATO DECRESCENTE AL ' TDAT
                  DELIMITED SIZE INTO RP-TIT1.
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           IF IF-ANNO = ZERO MOVE 'anaclf' TO ID-CLF
                             MOVE 'tabell' TO ID-TAB.
           IF IF-ANNO = 1    MOVE 'anacfx' TO ID-CLF
                             MOVE 'tabold' TO ID-TAB.
      *
           OPEN INPUT ANACLF
                      TABELL.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI  TO MASC.
           MOVE T01-MFOR  TO MASF.
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
      **** rel 7.2
           MOVE T01-CIVSO TO CIVSO.
      ************
      *
           MOVE 14 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB 
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-CDCOR TO CDCORR.
      *
           IF IF-ANNO = ZERO
              MOVE 'movmxx' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99
              MOVE 'movime' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99
           ELSE
              MOVE 'movoxx' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99
              MOVE 'movmol' TO ID-MOV
              PERFORM A00-TRATTA-FILE THRU A99.
      *
       STAMPA.
           MOVE ZERO TO TOTALE.
           MOVE ZERO TO NPAG XCRR.

           MOVE LOW-VALUE TO KEYLV SKWS-FAT.
           START WDSLAV KEY > SKEYLV1 INVALID GO TO S20. 
       S10.
           READ WDSLAV NEXT AT END GO TO S20.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO S10.
      *
           IF IF-FATMIN > ZERO
              IF WDS-FAT < IF-FATMIN GO TO S10.
      *
           MOVE KWS-COD TO PCOD.
           MOVE WDS-RGS TO PRGSOC.
           MOVE WDS-IND TO PINDIR.
           MOVE WDS-CAP TO PCAP.
           MOVE WDS-CIT TO PCITTA.
           MOVE WDS-PRV TO PPRV.
           MOVE WDS-FAT TO PSALDO.
           ADD WDS-FAT TO TOTALE.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.

           MOVE 1 TO XCRR.
           DELETE WDSLAV.
      *
           COPY 'grirpt-r'.
      *
           GO TO S10.
       S20.
           IF TOTALE = ZERO GO TO ENDA.
      *
           MOVE ALL '-' TO PSOT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 2 TO XCRR.
           MOVE 'T O T A L E' TO PCITTA.
           MOVE TOTALE TO PSALDO.
           MOVE 1 TO RP-FLGP.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ALL '=' TO PSOT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
       ENDA.
           PERFORM RPT-CL.
      *    
           COPY 'grirpt-e'.
      *
           CLOSE ANACLF.
           CLOSE TABELL.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       A00-TRATTA-FILE.
           OPEN INPUT MOVIME.
           IF SF-MOV > ZERO GO TO A99.
      *
      *** Vendite
           MOVE CIVAV TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      *
      *** Corrispettivi
           MOVE CDCORR TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      *
      *** Acquisti
           MOVE CIVAQ TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      *
      **** rel 7.2
      *** IVA Sospesa/Scissione pagamenti
           MOVE CIVSO TO CIVA.
           PERFORM B00-CONTO-IVA THRU B99.
      ************
           CLOSE MOVIME.
       A99. EXIT.
      *-----------------------------------
       B00-CONTO-IVA.
           MOVE ZERO TO MOV-NPRGI.
      *
           MOVE 99999   TO NREG.
      *
           MOVE LOW-VALUE TO KEYMV.
           MOVE KAZ-COD   TO KMV-AZI.
           MOVE CIVA      TO KMV-CON.
           MOVE PKDT1     TO KMV-DAT.
           START MOVIME KEY > KEYMV INVALID GO TO B90.
       B10.
           READ MOVIME NEXT INTO REKMOV AT END GO TO B90.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO B10.
           IF KMV-AZI > KAZ-COD GO TO B90.
           IF KMV-CON > CIVA    GO TO B90.
           IF KMV-DAT > PKDT2   GO TO B90.
      *
           IF MOV-FLAG = 1 GO TO B10.
      *
           IF CIVA = CIVAV
              IF MOV-TIP = 4 GO TO B10.
      *
           IF KMV-CON = CDCORR AND MOV-TREG NOT = 2
              GO TO B10.
      *
           MOVE MOV-PART  TO PART1.
           MOVE PART1     TO PART.
           IF IF-TIPST = ZERO AND MPART NOT = MASC GO TO B10.
           IF IF-TIPST = 1    AND MPART NOT = MASF GO TO B10.
      *
           IF CPART < IF-COD-1 OR > IF-COD-2 GO TO B10.
      *
      **** rel 7.2
           MOVE ZERO TO FLGIS.
      ************
           IF MOV-NREG NOT = NREG 
              PERFORM C00-CAMBIO-DOC THRU C99.
      **** rel 7.2
           IF FLGIS = 2
              GO TO B10.
      ************
      *
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-MOV
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
      *
           IF MOV-TIP = 4 MOVE MOV-IML TO IMP
           ELSE           MOVE MOV-IMP TO IMP.
      *
           IF TIPOP = 8 ADD IMP TO TACCR 
                        COMPUTE IMP = - IMP.
      *
           IF T03-TPIVA < 2 OR T03-TPIVA = 7
              ADD IMP TO IMPON.
      *
           IF T03-TPIVA > 1 AND T03-TPIVA < 6
              ADD IMP TO ESENT.
      *
           IF T03-TPIVA = 6 
              ADD IMP TO NIMPO
              IF SEGNO = ZERO ADD 1 TO NOPNI
              ELSE            SUBTRACT 1 FROM NOPNI.
      *
           IF MOV-TIP = 4 MOVE MOV-INL TO IVN
           ELSE           MOVE MOV-IVN TO IVN.
      *
           IF KMV-CON = CDCORR AND MOV-TREG = 2
                MOVE IVN TO IVA
           ELSE COMPUTE IVA = MOV-IMPO + IVN.
      *
           IF TIPOP = 8 SUBTRACT IVA FROM IMIVA
           ELSE         ADD IVA TO IMIVA.
      *
           GO TO B10.
       B90.
           PERFORM C00-CAMBIO-DOC THRU C50.
       B99. EXIT.
      *-----------------------------------
       C00-CAMBIO-DOC.
           IF NREG = 99999 GO TO C50.
      *
           MOVE PARTS     TO PART.
      *
           MOVE CPART     TO KWS-COD.
           READ WDSLAV INVALID MOVE ZERO TO RF-LAV.
      *
           MOVE KAZ-COD  TO KCF-AZI.
           MOVE PART     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      *
           COMPUTE TOTFAT = WDS-FAT + IMPON + NIMPO + ESENT.
      *
           MOVE ZERO TO RF-LAV.
           MOVE ZERO TO KWS-FAT
                        WDS-FAT.
           COMPUTE KWS-FAT = 99999999999 - TOTFAT.
           MOVE CLF-CD    TO KWS-COD.
           MOVE CLF-RGSOC TO WDS-RGS.
           MOVE CLF-INDIR TO WDS-IND.
           MOVE CLF-CAP   TO WDS-CAP.
           MOVE CLF-CITTA TO WDS-CIT.
           MOVE CLF-PRV   TO WDS-PRV.
           MOVE TOTFAT    TO WDS-FAT.
           IF SF-LAV = ZERO
              REWRITE RF-LAV INVALID MOVE 'RW LAV' TO MESS
                                     GO TO ERRIO
           ELSE
              WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS
                                   GO TO ERRIO.
       C50. EXIT.
       C60.
           MOVE MOV-NREG  TO NREG.
           MOVE MOV-TREG  TO TREG.
           MOVE MOV-PART  TO PARTS.
      *
           MOVE ZERO TO IMPON NIMPO ESENT IMIVA TACCR.
           MOVE ZERO TO NFATT NOPNI NACCR.
      *
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-MOV
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE T02-SEGNO TO SEGNO.
           MOVE T02-TIPOP TO TIPOP.
      **** rel 7.2
           MOVE T02-FLGIS TO FLGIS.
      ************

           IF T02-CTRFT > ZERO
              IF SEGNO = ZERO ADD 1 TO NFATT
              ELSE SUBTRACT 1 FROM NFATT.

           IF T02-CTRAC > ZERO
              IF SEGNO = ZERO ADD 1 TO NACCR
              ELSE SUBTRACT 1 FROM NACCR.
       C99. EXIT.
      *-----------------*
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Indirizzo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Cap' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Citta'' ' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Totale fatturato' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
