       IDENTIFICATION DIVISION.
       PROGRAM-ID. C71AFT.
      **** rel 7.1
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'grifatsl'.
           COPY 'griaftsl'.
           COPY 'gritabsl'.
           SELECT O-APPFAT  ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC
                  RECORD KEY O-KEYAFT
                  STATUS SF-O-AFT.
       DATA DIVISION.
       FILE SECTION.
           COPY 'grifat'.
           COPY 'griaft'.
           COPY 'gritab'.
       FD  O-APPFAT LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-O-AFT
           RECORD 200 DATA RECORD O-RF-AFT.
       01  O-RF-AFT.
           02 O-KEYAFT.
              05 O-KAFT-AZI  PIC 999.
              05 O-KAFT-TDOC PIC 9.
              05 O-KAFT-NUM  PIC 9(5) COMP-3.
           02 REKAFT.
              05 O-AFT-IPA     PIC X(6).
              05 O-AFT-CIG     PIC X(10).
              05 O-AFT-CUP     PIC X(15).
              05 O-AFT-TIPO    PIC 9.
              05 O-FILLER     PIC X(161).
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'grit35rk'.
           COPY '_parzf'.
           COPY '_parx'.
           COPY '_wconf'.
           COPY 'parcdt'.
       01  ID-AFT     PIC X(15) VALUE 'appfat'.
       01  ID-O-AFT   PIC X(15) VALUE '_afat'.
       01  ID-FAT     PIC X(15) VALUE 'fattur'.
       01  ID-TAB     PIC X(15) VALUE 'tabell'.
      *
       01  AREE-MS.
           05 MESS     PIC X(40) VALUE SPACE.
           05 IDE-DES  PIC X(20) VALUE SPACE.
           05 SF-AFT   PIC XX.
           05 SF-O-AFT PIC XX.
           05 SF-FAT   PIC XX.
           05 SF-TAB   PIC XX.
      *
       01  W-LINEE    PIC X(80) VALUE ALL '-'.
      *---------------------------------------------------------
      * Parametri CBL_CHECK_EXIST_FILE
       01  FILE-NAME          PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
       01  STATUS-CODE        PIC X(2)   COMP-X.
      *---------------------------------------------------------
      * Parametri CBL_RENAME_FILE
       01  OLD-FILE-NAME       PIC X(60).
       01  NEW-FILE-NAME       PIC X(60).
      *---------------------------------------------------------
       SCREEN SECTION.
           COPY '_scrlog'.
       01  SCR000.
           05 LINE 1 COLUMN 20 VALUE
           'CONVERSIONE APPOGGIO FATTURE'.
           05 LINE 2 COLUMN 1 PIC X(80) FROM W-LINEE.
       PROCEDURE DIVISION.
           COPY 'declxer1'.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==AFT==
                                   ==NFILE== BY ==APPFAT==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==FAT==
                                   ==NFILE== BY ==FATTUR==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==TAB==
                                   ==NFILE== BY ==TABELL==.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==O-AFT==
                                   ==NFILE== BY ==O-APPFAT==.
      *
           COPY '_dclxer2'.
       INIZIO.
      *

           MOVE ID-AFT TO FILE-NAME.
           CALL "CBL_CHECK_FILE_EXIST" USING FILE-NAME
                                             FILE-DETAILS
                               RETURNING STATUS-CODE.
           IF STATUS-CODE NOT = ZERO
              MOVE SPACE TO MESS
              STRING 'File ' DELIMITED SIZE
                     ID-AFT DELIMITED SPACE
                     ' inesist.' INTO MESS
              GO TO ERRIO.
       
           MOVE ID-O-AFT TO FILE-NAME.
           CALL "CBL_CHECK_FILE_EXIST" USING FILE-NAME
                                             FILE-DETAILS
                               RETURNING STATUS-CODE.
           IF STATUS-CODE = ZERO
              MOVE SPACE TO MESS
              STRING 'File ' DELIMITED SIZE
                     ID-O-AFT DELIMITED SPACE
                     ' esist.' INTO MESS
              GO TO ERRIO.

           MOVE ID-AFT   TO OLD-FILE-NAME
           MOVE ID-O-AFT TO NEW-FILE-NAME.
           CALL "CBL_RENAME_FILE" USING OLD-FILE-NAME
                                        NEW-FILE-NAME
                             RETURNING STATUS-CODE.
           IF STATUS-CODE NOT = ZERO
              MOVE 'Err rename file' TO MESS
              GO TO ERRIO.
      *
           MOVE SPACE TO OLD-FILE-NAME.
           STRING ID-AFT DELIMITED SPACE
                  '.idx' DELIMITED SIZE INTO OLD-FILE-NAME.
           MOVE SPACE TO NEW-FILE-NAME.
           STRING ID-O-AFT DELIMITED SPACE
                  '.idx' DELIMITED SIZE INTO NEW-FILE-NAME.
           CALL "CBL_RENAME_FILE" USING OLD-FILE-NAME
                                        NEW-FILE-NAME
                               RETURNING STATUS-CODE.
           IF STATUS-CODE NOT = ZERO
              MOVE 'Err rename file.IDX' TO MESS
              GO TO ERRIO.
      *
           DISPLAY SCRLOG.
           DISPLAY SCR000.
      *
           MOVE 2 TO C1DEF.
           CALL 'rxcnf' USING  PARX CNF1.
           IF X-COD > ZERO GO TO FINE.
      *
           CALL 'o-appfat'.
           OPEN INPUT APPFAT.
           IF SF-AFT NOT = ZERO
              MOVE 'Err crea file' TO MESS
              GO TO ERRIO.
           CLOSE APPFAT.
      *
           OPEN INPUT O-APPFAT.
           OPEN I-O APPFAT.
           OPEN INPUT TABELL.
      *
           MOVE 35        TO T35-TIP.
           MOVE ZERO      TO T35-CDAZ.
           MOVE LOW-VALUE TO T35-CATT.
      *
           MOVE T35-KEYID  TO KEYTB.
           START TABELL KEY > KEYTB INVALID GO TO END-TAB.
       LOOP-TAB.
           READ TABELL NEXT INTO REKT35 AT END GO TO END-TAB. 
           IF SF-TAB = '9D' OR '9A' OR '35' GO TO LOOP-TAB.
           IF T35-TIP > 35 GO TO END-TAB.
           IF T35-FELE = ZERO GO TO LOOP-TAB.
      *     
           CLOSE FATTUR.
           IF T35-CATT NOT = ZERO
              MOVE SPACE TO ID-FAT
              STRING 'fattur' T35-CATT DELIMITED SIZE INTO ID-FAT.
           OPEN INPUT FATTUR.
      *
           MOVE LOW-VALUE TO O-KEYAFT.
           START O-APPFAT KEY > O-KEYAFT INVALID GO TO END-AFT.
       LOOP-AFT.
           READ O-APPFAT NEXT AT END GO TO END-AFT. 
           IF SF-O-AFT = '9D' OR '9A' OR '35' GO TO LOOP-AFT.
      *
           MOVE O-KEYAFT TO KEYFT.
           READ FATTUR INVALID GO TO LOOP-AFT. 
      *
           MOVE KEYFT   TO KEYAFT.
           MOVE T35-CATT TO KAFT-CATT.
           READ APPFAT NOT INVALID
                GO TO LOOP-AFT.
           MOVE KEYFT   TO KEYAFT.
           MOVE T35-CATT TO KAFT-CATT.
           MOVE O-AFT-IPA  TO AFT-IPA.
           MOVE O-AFT-CIG  TO AFT-CIG.
           MOVE O-AFT-CUP  TO AFT-CUP.
           MOVE O-AFT-TIPO TO AFT-TIPO.
           WRITE RF-AFT INVALID PERFORM INVK-AFT
                                GO TO ERRIO.
           GO TO LOOP-AFT.
       END-AFT.
      *
           GO TO LOOP-TAB.
       END-TAB.
           PERFORM CLOSE-FILE.
      *
           GO TO FINE.
      *------------------*
       CLOSE-FILE.
           CLOSE APPFAT.
           CLOSE TABELL.
           CLOSE FATTUR.
      *------------------*
       ERRIO.
           COPY '_errio'.
           PERFORM CLOSE-FILE.
           STOP RUN. 
      *------------------*
       FINE.
           EXIT PROGRAM.
           STOP RUN. 
      *------------------*
           COPY '_errmes'.
           COPY 'griafter'.
           COPY 'grifater'.
           COPY 'gritaber'.
           COPY '_grixxxer'.
      *------------------*
