       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT170.
      *
      * OGGETTO: Eliminazione fatture
      *
      **** rel 4.0
      * ricompilato
      ************
      **** rel 1.2
      * ricompilato per variazione tracciato FATTUR
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'grifatsl'.
      **** rel 1.2
           COPY 'gribfasl'.
      ************
           COPY 'griazisl'. 
      **** rel 7.1
           COPY 'griaftsl'. 
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'grifat'.
      **** rel 1.2
           COPY 'gribfa'.
      ************
           COPY 'griazi'. 
      **** rel 7.1
           COPY 'griaft'. 
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 5.1
           COPY 'pardag'.
      ************
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
       01  ID-FAT  PIC X(15) VALUE 'fattur'.
      **** rel 1.2
       01  ID-BFA  PIC X(15) VALUE 'bolfat'.
      ************
      **** rel 7.1
       01  ID-AFT  PIC X(15) VALUE 'appfat'.
      ************
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-FAT  PIC XX.
      **** rel 1.2
           05 SF-BFA  PIC XX.
      ************
      **** rel 7.1
           05 SF-AFT  PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
      **** rel 5.0
           05 DATA1    PIC 9(5) COMP-3.
           05 DATA2    PIC 9(5) COMP-3.
      ************
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-CATT      PIC X.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TDOC-1    PIC 9.
           05 IF-TDOC-2    PIC 9.
           05 IF-FAT-1     PIC 9(5).
           05 IF-FAT-2     PIC 9(5).
           05 IF-TPELI     PIC 9.
      **** rel 5.0
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'. 
           COPY 'dclfat'.
      **** rel 1.2
           COPY 'dclbfa'.
      ************
      **** rel 7.1
           COPY 'dclaft'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vfat170: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE FATTUR.
      **** rel 7.1
           CLOSE APPFAT.
      ************
      **** rel 1.2
           CLOSE BOLFAT.
      ************
           CLOSE ANAAZI.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'. 
           COPY 'grifater'.
      **** rel 1.2
           COPY 'gribfaer'.
      ************
      **** rel 7.1
           COPY 'griafter'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
      **** rel 2.0
           MOVE 'fattur' TO ID-FAT.
      ************
           IF IF-CATT NOT = ZERO
              MOVE SPACE TO ID-FAT
              STRING 'fattur' IF-CATT DELIMITED SIZE INTO ID-FAT.
      *
           OPEN INPUT ANAAZI.
           OPEN I-O   FATTUR.
      **** rel 1.2
           OPEN I-O   BOLFAT.
      ************
      **** rel 7.1
           OPEN I-O   APPFAT.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-TDOC-1
                           IF-TDOC-2
                           IF-FAT-1
                           IF-FAT-2
                           IF-TPELI.
      **** rel 5.0
           MOVE ZERO TO IF-DATA-1
                        IF-DATA-2
                        DATA1
                        DATA2.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TDOC-1.
           MOVE 'IF-TDOC-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TDOC-1.
           IF IF-TDOC-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-TDOC-1.
      *
       V-TDOC-2.
           MOVE 'IF-TDOC-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TDOC-2.
           IF IF-TDOC-2 < IF-TDOC-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-TDOC-2.
      *
       V-FAT-2.
           MOVE 'IF-FAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FAT-2.
           IF IF-FAT-2 < IF-FAT-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-FAT-2.
      *
       V-TPELI.
           MOVE 'IF-TPELI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPELI.
           IF NOT (IF-TPELI = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPELI.
      *
      **** rel 5.0
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           IF IF-DATA-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATA1.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATA2.
           IF DATA2 < DATA1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
      ************
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           MOVE KAZ-COD   TO KFT-AZI.
           MOVE IF-TDOC-1 TO KFT-TDOC.
       L035.
           MOVE IF-FAT-1  TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO END-RUN-ELABORA.
       L040.
           READ FATTUR NEXT AT END GO TO END-RUN-ELABORA.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO L040.
           IF KFT-AZI  > KAZ-COD   GO TO END-RUN-ELABORA.
           IF KFT-TDOC > IF-TDOC-2 GO TO END-RUN-ELABORA.
           IF KFT-NUM  < IF-FAT-1  GO TO L035.
           IF KFT-NUM  > IF-FAT-2 
              ADD 1 TO KFT-TDOC
              GO TO L035.
           IF IF-TPELI = ZERO
              IF FAT-STATU NOT = 1 GO TO L040.
      **** rel 5.0
           IF FAT-DATA < DATA1 OR > DATA2 GO TO L040.
      ************
      **** rel 1.2
           PERFORM DEL-BFA THRU EX-DEL-BFA.
      ************
      **** rel 5.1
           MOVE 'c'      TO DAG-FUN.
           MOVE KFT-AZI  TO DAG-AZI.
           MOVE 'FAT'    TO DAG-TIP.
           MOVE KEYFT    TO DAG-KFD.
           MOVE FAT-CATT TO DAG-KFD(10:1).
           CALL 'rdalg' USING PARDAG.
      ************
           DELETE FATTUR INVALID KEY PERFORM INVK-FAT GO TO ERRIO.
      **** rel 7.1
           MOVE KEYFT TO KEYAFT.
           MOVE FAT-CATT TO KAFT-CATT.
           DELETE APPFAT.
      ************
           GO TO L040.
       END-RUN-ELABORA.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
      **** rel 1.2
      * eliminazione file di raggruppamento bolle per fattura
       DEL-BFA.
           MOVE FAT-CATT TO KBFA-CATT.
           MOVE KEYFT    TO KBFA-KEYFT.
           MOVE ZERO     TO KBFA-PRG.
           START BOLFAT KEY NOT < KEYBFA INVALID GO TO EX-DEL-BFA.
       DEL-BFA-10.
           READ BOLFAT NEXT AT END GO TO EX-DEL-BFA.
           IF KBFA-CATT  > FAT-CATT GO TO EX-DEL-BFA.
           IF KBFA-KEYFT > KEYFT    GO TO EX-DEL-BFA.
           DELETE BOLFAT INVALID PERFORM INVK-BFA GO TO ERRIO.
           GO TO DEL-BFA-10.
       EX-DEL-BFA.
           EXIT.
      ************
