       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON410.
      *
      * Controllo sequenza protocolli
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           SELECT WDSLAV ASSIGN TO DISK ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV
                  ALTERNATE RECORD KEY SKEYLV1 =
                                       LAV-ACF LAV-NDOC LAV-DTDOC 
                                       LAV-NREG
                  WITH DUPLICATES
                  STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'grimov'.                                         
           COPY 'gritab'.
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 48 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-AZI   PIC 999.
              10 KLV-CONVA PIC 9(7).
              10 KLV-CATT  PIC X.
              10 KLV-NPRGI PIC 9(5).
              10 KLV-NUM   PIC 9(5).
           05 LAV-DAT      PIC 9(5).
           05 LAV-NREG     PIC 9(5).
           05 LAV-ACF    PIC 9(7).
           05 LAV-NDOC   PIC 9(5).
           05 LAV-DTDOC  PIC 9(5).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.                                       
           COPY 'grimovrk'.                                       
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  AREE-MS.
           05 SF-AZI PIC XX.
           05 SF-CLF PIC XX.
           05 SF-TAB PIC XX.
           05 SF-MOV PIC XX.
           05 SF-LAV PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DT1 PIC 9(5) COMP-3 VALUE ZERO.
           05 DT2 PIC 9(5) COMP-3 VALUE ZERO.
           05 COM-LAV.
              10 CML-AZI   PIC 999  VALUE ZERO.
              10 CML-CONVA PIC 9(7) VALUE ZERO.
              10 CML-CATT  PIC X    VALUE ZERO.
              10 CML-NPRGI PIC 9(5) VALUE ZERO.
              10 CML-NUM   PIC 9(5) VALUE ZERO.
              10 CML-DAT   PIC 9(5) VALUE ZERO.
              10 CML-NREG  PIC 9(5) VALUE ZERO.
           05 COMOD PIC 9(5) VALUE ZERO.
           05 CMDAT PIC 9(6) VALUE ZERO.
           05 CERR  PIC 9    VALUE ZERO.
           05 ERRORI.
              10 FILLER PIC X(40) VALUE
                                 'ERRORE DI SEQUENZA NELLA NUMERAZIONE'.
              10 FILLER PIC X(40) VALUE      'NUMERO PROTOCOLLO DOPPIO'.
              10 FILLER PIC X(40) VALUE 'ERRORE DI SEQUENZA NELLA DATA'.
              10 FILLER PIC X(40) VALUE 'DOPPIA REGISTRAZ.SOGGETTO/DOCUM
      -       'ENTO'.
           05 DSERR REDEFINES ERRORI PIC X(40) OCCURS 4.
      * Variabili per E00-ESTRA
      **** rel 7.2
      *    05 CIVA  PIC 9(7) COMP-3 VALUE ZERO.
           05 CIVA  PIC 9(7).
           05 CIVAV PIC 9(7).
           05 CIVAQ PIC 9(7).
           05 CIVSO PIC 9(7).
      ************
       01 COMACF.
           05 COM-ACF    PIC 9(7).
           05 COM-NDOC   PIC 9(5).
           05 COM-DTDOC  PIC 9(5).
           05 COM-NREG   PIC 9(5).

           COPY 'vcon410.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dcllav'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon410: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANACLF TABELL ANAAZI MOVIME WDSLAV.
           OPEN OUTPUT   WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movime' TO ID-MOV.
           IF IF-FL = 1    MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movmol' TO ID-MOV.
           OPEN INPUT ANACLF TABELL ANAAZI MOVIME.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID KEY PERFORM INVK-AZI GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA-2.
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           MOVE IF-DATA-1 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DT1.
           MOVE IF-DATA-2 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DT2.

           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 7.2
      *    MOVE T01-CIVAV TO CIVA.
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
           MOVE T01-CIVSO TO CIVSO.
           MOVE CIVAV TO CIVA.
           PERFORM E00-ESTRA THRU E99.
           MOVE CIVAQ TO CIVA.
      ************
           PERFORM E00-ESTRA THRU E99.
      **** rel 7.2
           MOVE CIVSO TO CIVA.
      ************
           PERFORM E00-ESTRA THRU E99.
      **** rel 7.2
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      ************
           MOVE ZERO TO XCRR COM-LAV.
           MOVE AZRGSOC TO TAZI.
           MOVE IF-DATA-1 TO TDAT1.
           MOVE IF-DATA-2 TO TDAT2.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'CONTROLLO SEQUENZA PROTOCOLLI DAL '
                   TDAT1  ' AL 'TDAT2 
                  DELIMITED SIZE INTO RP-TIT1.
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO ENDB.
       LOPL.
           READ WDSLAV NEXT AT END GO TO ENDB.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LOPL.
           IF CML-CONVA NOT = KLV-CONVA    GO TO LOP10.
           IF CML-CATT  NOT = KLV-CATT     GO TO LOP10.
           ADD 1 TO CML-NPRGI GIVING COMOD. 
           IF KLV-NPRGI < CML-NPRGI OR KLV-NPRGI > COMOD
                                    MOVE 1 TO CERR GO TO LOP05.
           IF CML-NPRGI = KLV-NPRGI AND CML-NREG NOT = LAV-NREG
                                    MOVE 2 TO CERR GO TO LOP05.
           IF LAV-DAT < CML-DAT     MOVE 3 TO CERR GO TO LOP05.
           GO TO LOP10.
       LOP05.
           MOVE CML-AZI   TO KMV-AZI.
           MOVE CML-CONVA TO KMV-CON.
           MOVE CML-DAT   TO KMV-DAT.
           MOVE CML-NUM   TO KMV-NUM.
           READ MOVIME INTO REKMOV INVALID PERFORM INVK-MOV
                                           GO TO ERRIO.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
           IF CML-CONVA = T01-CIVAQ MOVE 'A' TO PVA
           ELSE                     MOVE 'V' TO PVA.
           MOVE CML-CATT  TO PATT.
           MOVE CML-NPRGI TO PPROT.
           MOVE CML-DAT   TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDATA.
           MOVE CML-NREG  TO PREG.
           MOVE CML-AZI   TO KCF-AZI.
           MOVE MOV-ACF   TO KCF-COD PCLI.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS   TO PDSCLI.
           MOVE MOV-NDOC  TO PDOC.
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDTDOC.
           MOVE DSERR(CERR) TO PERR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE KLV-AZI   TO KMV-AZI.
           MOVE KLV-CONVA TO KMV-CON.
           MOVE LAV-DAT   TO KMV-DAT.
           MOVE KLV-NUM   TO KMV-NUM.
           READ MOVIME INTO REKMOV INVALID PERFORM INVK-MOV
                                           GO TO ERRIO.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
           IF KLV-CONVA = T01-CIVAQ MOVE 'A' TO PVA
           ELSE                     MOVE 'V' TO PVA.
           MOVE KLV-CATT  TO PATT.
           MOVE KLV-NPRGI TO PPROT.
           MOVE LAV-DAT   TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDATA.
           MOVE LAV-NREG  TO PREG.
           MOVE KLV-AZI   TO KCF-AZI.
           MOVE MOV-ACF   TO KCF-COD PCLI.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS   TO PDSCLI.
           MOVE MOV-NDOC  TO PDOC.
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDTDOC.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
       LOP10.
           MOVE RF-LAV TO COM-LAV.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO LOPL.
       ENDB.
           MOVE ZERO TO LAV-ACF LAV-NDOC LAV-DTDOC.
           MOVE ZERO TO COMACF.
           START WDSLAV KEY NOT < SKEYLV1 INVALID GO TO ENDC.
       RD-LAVC.
           READ WDSLAV NEXT AT END GO TO ENDC.
           IF COMACF NOT = ZERO
              IF ( LAV-ACF   = COM-ACF  AND 
                   LAV-NDOC  = COM-NDOC AND 
                   LAV-DTDOC = COM-DTDOC ) 
                   IF LAV-NREG NOT = COM-NREG
                      PERFORM ST-DOC-DOPPIO THRU S99.
           MOVE LAV-ACF   TO COM-ACF.
           MOVE LAV-NDOC  TO COM-NDOC.
           MOVE LAV-DTDOC TO COM-DTDOC.
           MOVE LAV-NREG  TO COM-NREG.
           MOVE RF-LAV    TO COM-LAV.
           DELETE WDSLAV.
      *
           COPY 'grirpt-r'.
      *
           GO TO RD-LAVC.
       ENDC.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *-------------*
       E00-ESTRA.
           MOVE KAZ-COD TO KMV-AZI.
           MOVE CIVA    TO KMV-CON.
           MOVE DT1     TO KMV-DAT.
           MOVE ZERO    TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID KEY GO TO E99.
       E10.
           READ MOVIME NEXT INTO REKMOV AT END GO TO E99.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO E10.
           IF KMV-AZI > KAZ-COD GO TO E99.
           IF KMV-CON > CIVA    GO TO E99.
           IF KMV-DAT > DT2     GO TO E99.
           IF MOV-FLAG = 1      GO TO E10.
      **** rel 7.2
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-MOV
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           IF T02-FLGIS = 2
              GO TO E10.
      ************
           MOVE KAZ-COD   TO KLV-AZI.
           MOVE CIVA      TO KLV-CONVA.
           MOVE MOV-CATT  TO KLV-CATT.
           MOVE MOV-NPRGI TO KLV-NPRGI.
           MOVE KMV-NUM   TO KLV-NUM.
           MOVE KMV-DAT  TO LAV-DAT.
           MOVE MOV-NREG TO LAV-NREG.
           MOVE MOV-ACF   TO LAV-ACF.
           MOVE MOV-NDOC  TO LAV-NDOC.
           MOVE MOV-DTDOC TO LAV-DTDOC.
           WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           GO TO E10.
       E99.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       ST-DOC-DOPPIO.
           MOVE CML-AZI   TO KMV-AZI.
           MOVE CML-CONVA TO KMV-CON.
           MOVE CML-DAT   TO KMV-DAT.
           MOVE CML-NUM   TO KMV-NUM.
           READ MOVIME INTO REKMOV INVALID PERFORM INVK-MOV
                                           GO TO ERRIO.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
           IF CML-CONVA = T01-CIVAQ MOVE 'A' TO PVA
           ELSE                     MOVE 'V' TO PVA.
           MOVE CML-CATT  TO PATT.
           MOVE CML-NPRGI TO PPROT.
           MOVE CML-DAT   TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDATA.
           MOVE CML-NREG  TO PREG.
           MOVE CML-AZI   TO KCF-AZI.
           MOVE MOV-ACF   TO KCF-COD PCLI.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS   TO PDSCLI.
           MOVE MOV-NDOC  TO PDOC.
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDTDOC.
           MOVE DSERR(4) TO PERR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE KLV-AZI   TO KMV-AZI.
           MOVE KLV-CONVA TO KMV-CON.
           MOVE LAV-DAT   TO KMV-DAT.
           MOVE KLV-NUM   TO KMV-NUM.
           READ MOVIME INTO REKMOV INVALID PERFORM INVK-MOV
                                           GO TO ERRIO.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
           IF KLV-CONVA = T01-CIVAQ MOVE 'A' TO PVA
           ELSE                     MOVE 'V' TO PVA.
           MOVE KLV-CATT  TO PATT.
           MOVE KLV-NPRGI TO PPROT.
           MOVE LAV-DAT   TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDATA.
           MOVE LAV-NREG  TO PREG.
           MOVE KLV-AZI   TO KCF-AZI.
           MOVE MOV-ACF   TO KCF-COD PCLI.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS   TO PDSCLI.
           MOVE MOV-NDOC  TO PDOC.
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT. 
           MOVE GGMMAA    TO CMDAT.
           MOVE CMDAT     TO PDTDOC.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
       S99.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'V/A' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Att.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Prot.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Reg.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Cliente/Fornitore' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Documento' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Errore' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
