       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORDC35.
      *
      *  Programma di controllo congruenza tra dati di testata 
      *  della bolla e i dati di testata dell'ordine che si
      *  vuole evadere.
      *
      *  Dati in input: azienda
      *                 n. bollettario
      *                 n. bolla
      *                 n. ordine
      *
      *  Dati in output: status (0 se dati congruenti)
      *
      **** rel 4.0
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribctsl'.
           COPY 'griordsl'.
      **** rel 7.1
           COPY 'griactsl'.
           COPY 'griaorsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribct'.
           COPY 'griord'.
      **** rel 7.1
           COPY 'griact'.
           COPY 'griaor'.
      ************
       WORKING-STORAGE SECTION.
       01  RELPRIMULA.
           05 FILLER PIC X(50) VALUE
              '@(#)Primula NT rel 5.0     GR Informatica'.
           05 FILLER PIC X     VALUE LOW-VALUE.
           COPY 'griordrk'.
           COPY 'parzf'.
      **** rel 5.0
           COPY 'parmb'.
      ************
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
      **** rel 7.1
       01  ID-ACT PIC X(15) VALUE 'appbct'.
       01  ID-AOR PIC X(15) VALUE 'appord'.
      ************
       01  COMODI.
           05 SF-BCT   PIC XX.
           05 SF-ORD   PIC XX.
      **** rel 7.1
           05 SF-ACT   PIC XX.
           05 SF-AOR   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-NUM       PIC 9.
           05 IF-BOL       PIC 9(5).
           05 IF-NORD      PIC 9(5).
           05 IF-ST        PIC 9.
      *
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclbct'.
           COPY 'dclord'.
      **** rel 7.1
           COPY 'dclact'.
           COPY 'dclaor'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.

           OPEN INPUT BOLCTE.
      **** rel 7.1
           OPEN INPUT APPBCT.
      ************
           MOVE IF-AZI TO KBC-AZI.
           MOVE IF-NUM TO KBC-NUM.
           MOVE IF-BOL TO KBC-BOL.
           READ BOLCTE INVALID PERFORM INVK-BCT
                               CLOSE BOLCTE
                               GO TO WARNING.
      **** rel 7.1
           MOVE IF-AZI TO KACT-AZI.
           MOVE IF-NUM TO KACT-NUM.
           MOVE IF-BOL TO KACT-BOL.
           READ APPBCT INVALID MOVE SPACE TO ACT-IPA
                                             ACT-CIG
                                             ACT-CUP. 
           CLOSE APPBCT.
      ************
           CLOSE BOLCTE.
      *          
           OPEN INPUT ORDCLI.
      **** rel 7.1
           OPEN INPUT APPORD.
      ************
           MOVE IF-AZI  TO KOR-AZI.
           MOVE IF-NORD TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID
                               PERFORM INVK-ORD
                               CLOSE ORDCLI
                               GO TO WARNING.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
      **** rel 7.1
           MOVE IF-AZI  TO KAOR-AZI.
           MOVE IF-NORD TO KAOR-NUM.
           READ APPORD INVALID MOVE SPACE TO AOR-IPA
                                             AOR-CIG
                                             AOR-CUP. 
           CLOSE APPORD.
      ************
           CLOSE ORDCLI.
      *
           IF ORD-CDCLI NOT = BCT-CLI
              MOVE 'Cliente diverso su ordine' TO MESS
              GO TO WARNING.
           IF ORD-VALUT NOT = BCT-VALUT
              MOVE 'Divisa diversa su ordine' TO MESS
              GO TO WARNING.
      **** rel 5.0
      *    IF ORD-CDEP NOT = BCT-CDEP
      *       MOVE 'Deposito diverso su ordine' TO MESS
      *       GO TO WARNING.
           IF ORD-CDEP NOT = BCT-CDEP
              MOVE 'Deposito diverso.' TO F-MES1
              MOVE 'Vuoi continuare?' TO F-MES2
              MOVE 2   TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '2' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP = 'N' 
                 MOVE 'Procedura interrotta.' TO MESS
                 GO TO WARNING.
      ************
      **** rel 6.3
           IF ORD-IFAT NOT = BCT-IFAT
              MOVE 'Dest. di fatturazione diverso su ordine' TO MESS
              GO TO WARNING.
      ************
      **** rel 7.1
           IF AOR-IPA NOT = SPACE
              IF AOR-IPA NOT = ACT-IPA
                 MOVE 'Codice IPA diverso su ordine' TO MESS
                 GO TO WARNING.
           IF AOR-CIG NOT = SPACE
              IF AOR-CIG NOT = ACT-CIG
                 MOVE 'Codice CIG diverso su ordine' TO MESS
                 GO TO WARNING.
           IF AOR-CUP NOT = SPACE
              IF AOR-CUP NOT = ACT-CUP
                 MOVE 'Codice CUP diverso su ordine' TO MESS
                 GO TO WARNING.
      ************
           IF ORD-LCONS NOT = BCT-LCONS
              MOVE 'Destinazione diversa su ordine' TO MESS
              GO TO WARNING.
           IF ORD-CATT  NOT = BCT-CATT
              MOVE 'Attivita'' diversa su ordine' TO MESS
              GO TO WARNING.
           IF ORD-PERSC NOT = BCT-SCBAS
              MOVE 'Sconto base diverso' TO F-MES1
              MOVE 1 TO F-NMES.
           IF ORD-CDPAG NOT = BCT-CPAG
              MOVE 'Pagamento diverso' TO F-MES2
              MOVE 2 TO F-NMES.
           IF ORD-CDESE NOT = BCT-ESIVA
              MOVE 'Trattamento IVA diverso ' TO F-MES3
              MOVE 3 TO F-NMES.
           IF F-NMES NOT = ZERO
              MOVE 'Vuoi continuare ?' TO F-MES4
      **** rel 2.0
              MOVE 4 TO F-NMES
      ************
              GO TO QUESTION.
           GO TO FINE.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       FINE.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gribcter'.
           COPY 'griorder'.
      **** rel 7.1
           COPY 'griaorer'.
           COPY 'griacter'.
      ************
           COPY 'grixxxer'.
