       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGALG. 
      *
      *    Interfaccia ALLEGA per scheda
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'grialgsl'.
      **** rel 6.2
           COPY 'gritalsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'grialg'.
      **** rel 6.2
           COPY 'grital'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parag'.
           COPY 'parla'.
       01  ID-ALG PIC X(15) VALUE 'allega'.
      **** rel 6.2
       01  ID-TAL PIC X(15) VALUE 'tipall'.
      ************
       01  COMODI.
           05 SF-ALG   PIC XX.
      **** rel 6.2
           05 SF-TAL   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 IF-AZI   PIC 9(3).
           05 IF-TIP   PIC X(3).
           05 IF-KEY   PIC X(40).
           05 IF-KFD   PIC X(40).
           05 K1       PIC X COMP-X.
           05 K2       PIC X COMP-X.
      **** rel 3.0a
           05 K3       PIC X COMP-X.
      *************
       LINKAGE SECTION.
           COPY 'grialgrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-ALG-CTRL
                                RG-ALG-REC
                                RA-ALG-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclalg'.
      **** rel 6.2
           COPY 'dcltal'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-ALG-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-ALG-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           IF (RG-ALG-FUN = 'N' OR 'n') AND
              (RG-ALG-EOF = 2 OR 3)     GO TO ESCI.
           IF (RG-ALG-FUN = 'P' OR 'p') AND
              (RG-ALG-EOF = 1 OR 2)     GO TO ESCI.
           MOVE RG-ALG-FUN   TO FUN.
           MOVE RG-ALG-IDX   TO IDX.
           MOVE RG-ALG-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-ALG-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgalg: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-ALG-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-ALG-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-ALG-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ALLEGA.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-ALG INVALID
              PERFORM INVK-ALG
              GO TO ERRIO.
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-ALG INVALID
              PERFORM INVK-ALG
              GO TO ERRIO.
           UNLOCK ALLEGA.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-ALG
              GO TO WARNING.
           IF RG-ALG-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE ALLEGA INVALID
              PERFORM INVK-ALG
              GO TO ERRIO.
           UNLOCK ALLEGA.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-ALG-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ALLEGA.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-ALG-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ALLEGA.
      **** rel 6.2
           CLOSE TIPALL.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-ALG-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-ALG-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'grialger'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN I-O ALLEGA.
      **** rel 6.2
           OPEN INPUT TIPALL.
      ************
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-ALG-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-ALG.
           MOVE SPACE TO KALG-TIP
                         KALG-KFD
                         KALG-COD
                         ALG-DESCR
                         ALG-NFILE
                         ALG-TFILE.
      *
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-ALG-AZI TO IF-AZI.
           MOVE RG-ALG-TIP TO IF-TIP.
           MOVE RG-ALG-KEY TO IF-KEY.

      * azzeramento aree interfaccia
           MOVE ZERO TO RG-ALG-REC.
           MOVE SPACE TO RG-ALG-TIP
                         RG-ALG-KEY
                         RG-ALG-COD
                         RG-ALG-DESCR
                         RG-ALG-NFILE
                         RG-ALG-TFILE.
           MOVE ZERO TO RA-ALG-AGG.
           MOVE SPACE TO RA-ALG-NOTE.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-ALG-AZI.
           MOVE IF-TIP TO RG-ALG-TIP.
           MOVE IF-KEY TO RG-ALG-KEY.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE 1          TO AG-FUN.
           MOVE RG-ALG-AZI TO AG-AZI.
           MOVE RG-ALG-TIP TO AG-TIP.
           MOVE RG-ALG-KEY TO AG-KEY.
           CALL 'rkalg' USING PARAG.
           IF AG-ST > ZERO GO TO ERRIO.
           MOVE AG-KFD     TO IF-KFD.
      *
           MOVE RG-ALG-AZI TO KALG-AZI.
           MOVE RG-ALG-TIP TO KALG-TIP.
           MOVE AG-KFD     TO KALG-KFD.
           MOVE RG-ALG-COD TO KALG-COD.
           MOVE KEYALG TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYALG.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ALLEGA INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ALLEGA KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-ALG > ZERO MOVE 7 TO RG-ALG-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ALLEGA PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ ALLEGA NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-ALG = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-ALG-EOF.
           MOVE KEYALG TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-ALG-EOF.
           IF RG-ALG-EOF = 4 MOVE 2 TO RG-ALG-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-ALG = LOW-VALUE GO TO EX-TEST-EOL.
           IF KALG-AZI = RG-ALG-AZI AND
              KALG-TIP = RG-ALG-TIP AND
              KALG-KFD = IF-KFD     GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE 1          TO AG-FUN.
           MOVE RG-ALG-AZI TO AG-AZI.
           MOVE RG-ALG-TIP TO AG-TIP.
           MOVE RG-ALG-KEY TO AG-KEY.
           CALL 'rkalg' USING PARAG.
           IF AG-ST > ZERO GO TO ERRIO.
      *
           MOVE RG-ALG-AZI    TO KALG-AZI.
           MOVE RG-ALG-TIP    TO KALG-TIP.
           MOVE AG-KFD        TO KALG-KFD.
           MOVE RG-ALG-COD    TO KALG-COD.
           MOVE RG-ALG-DESCR  TO ALG-DESCR.
           MOVE RG-ALG-NFILE  TO ALG-NFILE.
           MOVE RG-ALG-TFILE  TO ALG-TFILE.
      **** rel 7.2
           MOVE RG-ALG-FATTPA TO ALG-FATTPA.
      ************
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE 2        TO AG-FUN.
           MOVE KALG-AZI TO AG-AZI.
           MOVE KALG-TIP TO AG-TIP.
           MOVE KALG-KFD TO AG-KFD.
           CALL 'rkalg' USING PARAG.
           IF AG-ST > ZERO GO TO ERRIO.
      *
           MOVE KALG-AZI      TO RG-ALG-AZI.
           MOVE KALG-TIP      TO RG-ALG-TIP.
           MOVE AG-KEY        TO RG-ALG-KEY.
           MOVE KALG-COD      TO RG-ALG-COD.
           MOVE ALG-DESCR     TO RG-ALG-DESCR.
           MOVE ALG-NFILE     TO RG-ALG-NFILE.
           MOVE ALG-TFILE     TO RG-ALG-TFILE.
      **** rel 7.2
           MOVE ALG-FATTPA    TO RG-ALG-FATTPA.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
      ***
      *** implementare note aggiuntive
      ***
           MOVE SPACE TO RA-ALG-NOTE.
           MOVE ZERO  TO RA-ALG-NBYTE.
           MOVE ZERO  TO RA-ALG-FLGNOTE.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-ALG-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-COD.
           MOVE 'ALG-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD.
           IF RG-ALG-COD = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 6.2
           MOVE RG-ALG-AZI TO KTAL-AZI.
           MOVE RG-ALG-COD TO KTAL-COD.
           MOVE 'Tipo allegato non codificato' TO RG-ALG-DESCR.
           READ TIPALL NOT INVALID MOVE TAL-DESCR TO RG-ALG-DESCR.
      ************
       E-COD.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-ALG-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-NFILE.
           MOVE 'ALG-NFILE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NFILE.
           IF RG-ALG-NFILE = SPACE
              MOVE "E' necessario selezionare un file" TO MESS
              GO TO V-ERROR.
           PERFORM ESTRAI-TFILE THRU EX-ESTRAI-TFILE.
           IF RG-ALG-TFILE = SPACE
              MOVE "Tipo di file non gestibile" TO MESS
              GO TO V-ERROR.
           IF FUN NOT = 'V' GO TO E-NFILE.
      *
           MOVE 'C'          TO LA-FUN.
           MOVE RG-ALG-NFILE TO LA-NFILE.
           MOVE RG-ALG-TFILE TO LA-TFILE.
           CALL 'ralleg' USING PARLA.
           IF LA-ST > ZERO
                MOVE "Non e' configurata alcuna applicazione" TO F-MES1
                MOVE "per gestire il file selezionato"        TO F-MES2
                MOVE 2 TO F-NMES
                GO TO V-WARNING.
       E-NFILE.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       ESTRAI-TFILE.
           MOVE SPACE TO RG-ALG-TFILE.
           IF RG-ALG-NFILE = SPACE GO TO EX-ESTRAI-TFILE.
      **** rel 4.1a
      *    MOVE 60 TO K2.
           MOVE 150 TO K2.
      ************
           PERFORM UNTIL RG-ALG-NFILE(K2:1) NOT = SPACE
              SUBTRACT 1 FROM K2.
      **** rel 6.3
           IF RG-ALG-NFILE(K2:1) = '"' SUBTRACT 1 FROM K2.
      ************
           MOVE K2 TO K1.
           PERFORM UNTIL K1 = ZERO OR RG-ALG-NFILE(K1:1) = '.'
              SUBTRACT 1 FROM K1.
           IF K1 = ZERO GO TO EX-ESTRAI-TFILE.
           COMPUTE K2 = K2 - K1.
           IF K2 <= 4
              ADD 1 TO K1
      **** rel 3.0a
      *       MOVE RG-ALG-NFILE(K1:K2) TO RG-ALG-TFILE.
              MOVE RG-ALG-NFILE(K1:K2) TO RG-ALG-TFILE
              MOVE 4 TO K3 
              PERFORM UNTIL K3 = ZERO
                 IF RG-ALG-TFILE(K3:1) NOT = SPACE
      **** rel 6.3
      *             IF RG-ALG-TFILE(K3:1) = '"'
      *                MOVE SPACE TO RG-ALG-TFILE(K3:1)
      *             END-IF
      ************
                    MOVE 1 TO K3
                 END-IF
                 SUBTRACT 1 FROM K3
              END-PERFORM.
      *************
       EX-ESTRAI-TFILE.
           EXIT.
      *------------------
